
	TTL 'AERO'


	XREF VJ_STAR,T_ROLL,T_PTCH,T_YAW
*	XREF VJ_DOT

	INCLUDE	'COMN.ASM'

*	XDEF VGOVER,HEADUP,HEADING,ALTITUDE,AIRSPEED,VWTHRUST,HORIZ
*	XDEF VWHEX,AERO,VWBYTE,VWWORD

	XDEF FLY,FLY1,FLY2,EFLY2,FLY3,FLY4,FLY5,FLY6
	XDEF RUNWAY,RY1,RY2,RY3,RY4,RY5,RWMAT,SHOW	
	XDEF DX,DY,NUMPTS
	XDEF HORIZ,HZN2
	XDEF S2CRASH

	PAGE

	SECTION PROGRAM

*-------------------------------------------------------------------------------
* RUNWAY

DX:	DC.W	$0200
DY:	DC.W	$0200  
NUMPTS: DC.W	16

RUNWAY:
* Are we close enough?
	MOVE.W	(XT+UV2),D1
	MULS	D1,D1
	MOVE.W	(YT+UV2),D0
	MULS	D0,D0
	ADD.L	D0,D1
	MOVE.W	(ZT+UV2),D0
	MULS	D0,D0
	ADD.L	D0,D1			* D1 = XT*XT + YT*YT + ZT*ZT
	CMP.L	#$31000000,D1		* 7000*7000
	BLE	RY1
	RTS		

RY1:	MOVE.L	VG_PTR,A0
	MOVE.W	#$8040,(A0)+		* Center
	MOVE.W	#$7200,(A0)+		* Scale 2,0
	MOVE.W	#$6740,(A0)+		* White,$40
	MOVE.L	A0,VG_PTR

	MOVE.W	DX,D0
	MULS	(AX+UV2),D0
	ASL.L	#2,D0
	SWAP	D0
	MOVE.W	D0,TX			* TX = DX*AX	

	MOVE.W	DX,D0
	MULS	(AY+UV2),D0
	ASL.L	#2,D0
	SWAP	D0
	MOVE.W	D0,TY			* TY = DX*AY	

	MOVE.W	DX,D0
	MULS	(AZ+UV2),D0
	ASL.L	#2,D0
	SWAP	D0
	MOVE.W	D0,TZ			* TZ = DX*AZ			
	
*Do a line of dots

	MOVE.W	DY,D5
	MOVEA.L	#UV2,A0
	BSR	RWMAT			* Runway Matrix
	BSR	SHOW			* Calculate and show one line of dots

*Do another line of dots

	MOVE.W	DY,D5		
	NEG.W	D5
	MOVEA.L	#UV2,A0
	BSR	RWMAT			* Runway Matrix
	BSR	SHOW			* Calculate and show one line of dots
	RTS

SHOW:	
	MOVE.W	#0,A1			*Clear last VG Y position
	MOVE.W	A1,A2			*Clear last VG X position
	MOVE.W	NUMPTS,D7		* Do 32 points
	EXT.L	D7
	MOVEA.L	VG_PTR,A0

	CLR.L	D0			* D0 = TXX
	CLR.L	D1			* D1 = TYY
	CLR.L	D2			* D2 = TZZ

RY2:	
	ADD.W	TX,D0			*D0 = TXX = TXX + TX
	ADD.W	TY,D1			*D1 = TYY = TYY + TY
	ADD.W	TZ,D2			*D2 = TZZ = TZZ + TZ

	MOVE.W	XR,D3
	ADD.W	D0,D3			
	MOVE.W	D3,XP			* XP = XR + TXX

	MOVE.W	YR,D3
	ADD.W	D1,D3
	MOVE.W	D3,YP			* YP = YR + TYY
	
	MOVE.W	ZR,D3
	ADD.W	D2,D3
	MOVE.W	D3,ZP			* ZP = ZR + TZZ

*Is it visible?
	MOVE.W	XP,D3		* D3 = XP
	CMP.W	#$10,D3
	BLT	RY5		* If XP is less than $10 it is invisible	
	MOVE.W	YP,D4		* D4 = YP
	BPL	RY3
	NEG.W	D4		* Make D4 positive
RY3:	MOVE.W	ZP,D5		* D5 = ZP
	BPL	RY4
	NEG.W	D5		* Make D5 positive
RY4:	CMP.W	D3,D4		
	BGT	RY5		* If ABS(YP) .GT. ABS(ZP), it is invisible
	CMP.W	D3,D5		
	BGT	RY5		* If ABS(ZP) .GT. ABS(XP), it is invisible

* The point is visible
	MOVE.W	XP,D3		*D3 = 4000 max

*Screen Y
	CLR.L	D4
	MOVE.W	ZP,D4
	SWAP	D4
	ASR.L	#3,D4		*D4 = 1000 0000 max	
	
	DIVS	D3,D4		*D4=D4/D3 (max is 1000 0000/4000 = 4000)

	ASR.W	#4,D4		*D4 = Screen Y, max is 200

	MOVE.W	D4,A3		*Save current screen Y
	SUB.W	A1,D4		*D4 = New Y - Old Y
	MOVE.W	A3,A1		*Update Current Y	

*Screen X
	CLR.L	D5
	MOVE.W	YP,D5
	SWAP	D5
	ASR.L	#3,D5		*D5 = 1000 0000 max	
	
	DIVS	D3,D5		*D5=D5/D3 (max is 1000 0000/4000 = 4000)

	ASR.W	#4,D5		*D5 = Screen X, max is 200

	MOVE.W	D5,A4		*Save current screen X
	SUB.W	A2,D5		*D5 = New X - Old X
	MOVE.W	A4,A2		*Update Current X	

*Format the Vector
	AND.W	#$1FFF,D4
	MOVE.W	D4,(A0)+	* dy

	AND.W	#$1FFF,D5
	MOVE.W	D5,(A0)+	* dx

	MOVE.W	#$0,(A0)+	*VCTR 0,0,ON)
	MOVE.W	#$6000,(A0)+

*	MOVE.W	#VJ_DOT,(A0)+	* JSRL DOT [VCTR 0,0,ON; CENTER]
*	MOVE.W	#VJ_STAR,(A0)+	* JSRL STAR [VCTR 0,0,ON; CENTER]

RY5:	SUBQ.L	#1,D7
	BNE	RY2

	MOVE.W	#$8040,(A0)+	*Center
	MOVE.L	A0,VG_PTR

	RTS	
*-------------------------------------------------------------------------------
	PAGE
* RUNWAY MATRIX
*
*	XR = - AX*XT - BX*YT - CX*ZT + BX*Y
*	YR = - AY*XT - BY*YT - CY*ZT + BY*Y
*	ZR = - AZ*XT - BZ*YT - CZ*ZT + BZ*Y
*
* A0 points to Unit Vector Block
*
* D0 = XT
* D1 = YT
* D2 = ZT
*
* D5 = Y
* D6 = Rn * D6, also temp
* D7 is the Accumulator
*
RWMAT:	
	MOVE.W	XT(A0),D0	*D0 = XT
	MOVE.W	YT(A0),D1	*D1 = YT
	MOVE.W	ZT(A0),D2	*D2 = ZT

	CLR.L	D7		*clear accumulator
	MOVE.W	AX(A0),D6
	MULS	D0,D6		
	SUB.L	D6,D7		*D7= - AX*XT

	MOVE.W	BX(A0),D6
	MULS	D1,D6
	SUB.L	D6,D7		*D7= - AX*XT - BX*YT

	MOVE.W	CX(A0),D6
	MULS	D2,D6
	SUB.L	D6,D7		*D7= - AX*XT - BX*YT - CX*ZT

	MOVE.W	BX(A0),D6
	MULS	D5,D6
	ADD.L	D6,D7		*D7= - AX*XT - BX*YT - CX*ZT + BX*Y
	
	ASL.L	#2,D7
	SWAP	D7		* Readjust

	MOVE.W	D7,XR		*XR = - AX*XT - BX*YT - CX*ZT <<<<<<<<<<<<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AY(A0),D6
	MULS	D0,D6		
	SUB.L	D6,D7		*D7= - AY*XT

	MOVE.W	BY(A0),D6
	MULS	D1,D6
	SUB.L	D6,D7		*D7= - AY*XT + BY*YT

	MOVE.W	CY(A0),D6
	MULS	D2,D6
	SUB.L	D6,D7		*D7= - AY*XT + BY*YT + CY*ZT

	MOVE.W	BY(A0),D6
	MULS	D5,D6
	ADD.L	D6,D7		*D7= - AY*XT - BY*YT - CY*ZT + BY*Y
	
	ASL.L	#2,D7
	SWAP	D7		* Readjust

	MOVE.W	D7,YR		*YR = - AY*XT + BY*YT + CY*ZT <<<<<<<<<<<<<<<<<
*------------------------------------------------------------------------------
	CLR.L	D7		*clear accumulator
	MOVE.W	AZ(A0),D6
	MULS	D0,D6		
	SUB.L	D6,D7		*D7= - AZ*XT

	MOVE.W	BZ(A0),D6
	MULS	D1,D6
	SUB.L	D6,D7		*D7= - AZ*XT + BZ*YT

	MOVE.W	CZ(A0),D6
	MULS	D2,D6
	SUB.L	D6,D7		*D7= - AZ*XT + BZ*YT + CZ*ZT

	MOVE.W	BZ(A0),D6
	MULS	D5,D6
	ADD.L	D6,D7		*D7= - AZ*XT - BZ*YT - CZ*ZT + BZ*Y
	
	ASL.L	#2,D7
	SWAP	D7		* Readjust

	MOVE.W	D7,ZR		*ZR = - AZ*XT + BZ*YT + CZ*ZT <<<<<<<<<<<<<<<<<

	RTS
********************************************************************************
	PAGE
*Generate Horizon from UV2
*	A0 = Pointer to UV2
*
*	PX = (AX*AX + BX*BX)
*	T = (AX*AX + BX*BX) * 1.414
*	TBX = T*BX
*	TAX = T*AX
*	PZ1 = (AX-TBX)*AX + (BX+TAX)*BZ
*	PY1 = (AX-TBX)*AY + (BX+TAX)*BY
*	PZ2 = (AX+TBX)*AZ + (BX-TAX)*BX
*	PY2 = (AX+TBX)*AY + (BX-TAX)*BY

*	SY2 = K*PZ2/PX 	
*	SX1 = K*PY1/PX

* Uses D0 - D7,A0,A1,A2

* Takes 260 uS.

HORIZ	MOVEA.W	#UV2,A0
*Calculate PX
	MOVE.W	AX(A0),D0
	MULS	D0,D0		* D0=AX*AX
	MOVE.W	BX(A0),D1
	MULS	D1,D1		* D1=BX*BX
	ADD.L	D1,D0		* D0= PX = AX*AX+BX*BX, max = 4000*4000=1000 0000
	ASL.L	#2,D0
	SWAP	D0		* D0= PX = AX*AX+BX*BX, max = 4000

*In order for the horizon line to be visible, P must be greater than or equal
*to 0.34 . If 1.000 = 4000, then 0.34 = 15C2
	CMP.W	#$15C2,D0
	BGE	HZN2
	RTS			*If not, not
HZN2	
	MOVE.W 	#$5A7E,D1
	MULS	D0,D1		* D1= T = (AX*AX+BX*BX)*1.414, max = 169F8000
	ASL.L	#2,D1
	SWAP	D1		* D1= T = (AX*AX+BX*BX)*1.414, max = 5A7E
	
	MOVE.W	BX(A0),D2
	MULS	D1,D2		* D2 = TBX = T*BX = 169F8000 max
	ASL.L	#2,D2
	SWAP	D2		* D2 = TBX = T*BX = 5A7E max


	MOVE.W	AX(A0),D3
	MULS	D1,D3		* D3 = TAX = T*AX = 169F8000 max
	ASL.L	#2,D3
	SWAP	D3		* D3 = TAX = T*AX = 5A7E max

*Calculate PZ1,PY1
	MOVE.W	AX(A0),D7	* D7 = AX
	SUB.W	D2,D7		* D7 = AX-TBX
	MOVE.L	D7,D5		* [Save D5 = AX-TBX]
	MULS	AZ(A0),D7	* D7 = (AX-TBX)*AZ

	MOVE.W	BX(A0),D6	* D6 = BX
	ADD.W	D3,D6		* D6 = BX+TAX
	MOVE.L	D6,D4		* [Save D4 = BX+TAX]
	MULS	BZ(A0),D6	* D6 = (BX+TAX)*BZ

	ADD.L	D6,D7
	
	MULS	AY(A0),D5	* D5 = (AX-TBX)*AY
	MULS	BY(A0),D4	* D4 = (BX+TAX)*BY
	ADD.L	D4,D5		

	MOVE.L	D7,A1		* Save PZ1 long in A1
	MOVE.L	D5,A2		* Save PY1 long in A2

*Calculate PZ2,PY2
	MOVE.W	AX(A0),D7	* D7 = AX
	ADD.W	D2,D7		* D7 = AX+TBX
	MOVE.L	D7,D5		* [Save D5 = AX+TBX]
	MULS	AZ(A0),D7	* D7 = (AX+TBX)*AZ

	MOVE.W	BX(A0),D6	* D6 = BX
	SUB.W	D3,D6		* D6 = BX-TAX
	MOVE.L	D6,D4		* [Save D4 = BX-TAX]
	MULS	BZ(A0),D6	* D6 = (BX-TAX)*BZ

	ADD.L	D6,D7
	
	MULS	AY(A0),D5	* D5 = (AX+TBX)*AY
	MULS	BY(A0),D4	* D4 = (BX-TAX)*BY
	ADD.L	D4,D5		

* D7 = PZ2, D5 = PY2, A1 = PZ1, A2 = PY1 [all are in long format for dividend]
* D0 = PX [normal for divisor]
* Project the Horizon points
	DIVS	D0,D7		*D7 = PZ2/PX 	
	ASR.W	#5,D7		*D7 = SY2 = K*PZ2/PX 	

	DIVS	D0,D5		*D5 = PY2/PX
	ASR.W	#5,D5		*D5 = SX2 = K*PY2/PX

	MOVE.L	A1,D4	
	DIVS	D0,D4		*D4 = PZ1/PX
	ASR.W	#5,D4		*D4 = SY1 = K*PZ1/PX

	MOVE.L	A2,D3
	DIVS	D0,D3		*D3 = PY1/PX
	ASR.W	#5,D3		*D3 = SX1 = K*PY1/PX

* Add Horizon Line to VG Buffer

	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+	*SCALE: BIN 2, LIN 0
	MOVE.W	#$6120,(A0)+	*STAT: COLOR Blue, ZSCALE 20

	AND.W	#$1FFF,D4
	MOVE.W	D4,(A0)+	*dy = SY1
	AND.W	#$1FFF,D3	* no Z
	MOVE.W	D3,(A0)+	*dx = SX1

	SUB.W	D4,D7
	AND.W	#$1FFF,D7
	MOVE.W	D7,(A0)+	*dy = SY2-SY1	

	SUB.W	D3,D5		
	OR.W	#$0E000,D5	* Z=7
	MOVE.W	D5,(A0)+	*dx = SX2-SX1

	MOVE.W	#$8040,(A0)+	* Center
	MOVE.L	A0,VG_PTR

	RTS			* All done
*------------------------------------------------------------------------------
	PAGE
FLY1:	
* Simple motion for Ship 1
* Takes about 440 us for three axes 
* YAW TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 79 MAX
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	MOVE.B	POT1,D0			*Yaw Pot
	NEG.B	D0
	JSR	T_YAW

* PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	MOVE.B	POT0,D0			*Pitch Pot
	JSR	T_PTCH

*ROLL	
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	CLR.B	D0
	BTST	#05,INPUTS
	BNE	R01
	MOVE.B	#-$10,D0

R01	BTST	#04,INPUTS
	BNE	R02
	MOVE.B	#$10,D0

R02	BSR	T_ROLL
*----------------------------
	MOVEA.W	#UV2,A0		*UV2 is the Working Set for Ship 1
	BSR	FLY

	MOVE.W	THRUST(A0),D0	* AIRSPEED = THRUST	
	SUB.W	ASPD,D0
	ASR.W	#3,D0
	ADD.W	D0,ASPD		* ASPD = (NEW-OLD)/8 + OLD
	
	RTS
*===============================================================================
	PAGE
FLY2:	
* Simple motion for Ship 2
* Takes about 440 us for three axes 
* YAW TIC
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 79 MAX
	MOVEA.W	#UV3,A0		*UV3 is the Primary Set for Ship 2
	MOVE.B	POT3,D0		*Yaw Pot
	NEG.B	D0
	JSR	T_YAW

*PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVEA.W	#UV3,A0		*A0=Ship 2 primary
	MOVE.B	POT2,D0		*Pitch Pot
	JSR	T_PTCH

*ROLL	
	MOVEA.W	#UV3,A0		*A0=Ship 2 primary
	CLR.B	D0
	BTST	#05,INPUTS
	BNE	FR01
	MOVE.B	#-$10,D0

FR01	BTST	#04,INPUTS
	BNE	FR02
	MOVE.B	#$10,D0

FR02	BSR	T_ROLL
*----------------------------
EFLY2:	MOVEA.W	#UV4,A0		*UV4 is the Working Set for Ship 2
	BSR	FLY
	RTS
*-----------------------------------------------------------------------------
	PAGE
* A0 points to ship's working vectors
* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
FLY	MOVE.W	THRUST(A0),D1
	ASR.W	#1,D1		*D1 = scaled thrust = 2000 max

	MOVE.W	AX(A0),D0
	MULS	D1,D0		* AX * THRUST, MAX = 1000 0000
	ASL.L	#2,D0		* MAX = 2000 0000
	SUB.L	VX(A0),D0
	ASR.L	#5,D0		
	ADD.L	D0,VX(A0)	* VX = OLD + (NEW-OLD)/32	

	MOVE.W	BX(A0),D0
	MULS	D1,D0		* BX * THRUST, MAX = 1000 0000
	ASL.L	#2,D0		* MAX = 2000 0000
	SUB.L	VY(A0),D0
	ASR.L	#5,D0		
	ADD.L	D0,VY(A0)	* VY = OLD + (NEW-OLD)/32	
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0		* CX * THRUST, MAX = 1000 0000
	ASL.L	#2,D0		* MAX = 2000 0000
	SUB.L	VZ(A0),D0
	ASR.L	#5,D0		
	ADD.L	D0,VZ(A0)	* VZ = OLD + (NEW-OLD)/32	
*----------------
*Update the position
UPOS	MOVE.W	VX(A0),D0
	ASR.W	#8,D0			* K * VX
	ADD.W	D0,XT(A0)		* XT = XT + K*VX

	MOVE.W	VY(A0),D0
	ASR.W	#8,D0			* K * VY
	ADD.W	D0,YT(A0)		* YT = YT + K*VY

	MOVE.W	VZ(A0),D0
	ASR.W	#8,D0			* K * VZ
	ADD.W	D0,ZT(A0)		* ZT = ZT + K*VZ

	CMP.W	#$40,ZT(A0)
	BGE	UPOSA

	CLR.L	VZ(A0)			* zero VZ on the ground
	MOVE.W	#$40,ZT(A0)		* Eye level 

UPOSA	RTS
*-----------------------------------------------------------------------------
	PAGE
	XDEF GRAV,MODE,TSCALE,TURNSC,POS,POS2,WING
	XDEF UPOS,YWIND,YW3,VCOM,FSHIFT,FORCE,PSHIFT

MODE:	DC.W	$1		* 0=Airplane, 1=Straight, 2=Helicopter
TSCALE: DC.W	$4000		* Thrust scaling
GRAV:	DC.W 	$1000		* Gravity
TURNSC  DC.W	$28		* Turning Scale
FSHIFT	DC.W	$06		* FORCE SCALING (SHIFTS)
PSHIFT	DC.W	$09		* POSITION SCALING (SHIFTS)

FLY3:	
* Crude Airplane Aerodynamics for Ship 1
* ROLL TIC
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 79 MAX
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	MOVE.B	POT1,D0			*Roll Pot
	JSR	T_ROLL

* PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary
	MOVE.B	POT0,D0			*Pitch Pot
	JSR	T_PTCH

* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
FY3B	MOVEA.W	#UV2,A0		*UV2 is the Working Set
	
* Thrust
	MOVE.W	THRUST(A0),D1
	MULS	TSCALE,D1	
	ASL.L	#2,D1
	SWAP	D1		*D1 = scaled thrust

	MOVE.W	AX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* AX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FX1		* FX = THRUST*AX, MAX = 4000	

	MOVE.W	BX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* BX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FY1		* FY = THRUST*BX, MAX=4000
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* CX * THRUST, MAX = 1000 0000
	SWAP	D0
	MOVE.W	D0,FZ1		* FZ = THRUST*CX, MAX=4000	

WING:	BSR	VCOM

	MOVE.W	XP,D0		* USE VXCOM FOR AIRSPEED
	TST.W	D0
	BPL	WNG2
	NEG.W	D0
WNG2	SUB.W	ASPD,D0
	ASR.W	#3,D0
	ADD.W	D0,ASPD		* ASPD = (NEW-OLD)/8 + OLD

	MOVE.W	ZP,D1		* D1= - VZCOMP = QW

	MOVE.W	AZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FX1		* FX = THRUST*AX + QW*AZ	

	MOVE.W	BZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FY1		* FY = THRUST*BX + QW*BZ	

	MOVE.W	CZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	SUB.W	GRAV,D0		
	ADD.W	D0,FZ1		* FZ = THRUST*CX + QW*CZ - GRAVITY

FORCE:
	MOVE.W	FSHIFT,D6

	CLR.L	D0
	MOVE.W	FX1,D0
	SWAP	D0
	SUB.L	VX1,D0
	ASR.L	D6,D0
	ADD.L	D0,VX1		* VX = VX + (FX-VX)*K = VX + K*FX - K*VX

	CLR.L	D0
	MOVE.W	FY1,D0
	SWAP	D0
	SUB.L	VY1,D0
	ASR.L	D6,D0
	ADD.L	D0,VY1		* VY = VY + (FY-VY)*K = VY + K*FY - K*VY

	CLR.L	D0
	MOVE.W	FZ1,D0
	SWAP	D0
	SUB.L	VZ1,D0
	ASR.L	D6,D0
	ADD.L	D0,VZ1		* VZ = VZ + (FZ-VZ)*K = VZ + K*FZ - K*VZ

*Update the position
POS:	
	MOVE.W	PSHIFT,D6

	MOVE.L	VX1,D0
	ASR.L	D6,D0
	ADD.L	D0,XT1			* XT = XT + K*VX

	MOVE.L	VY1,D0
	ASR.L	D6,D0
	ADD.L	D0,YT1			* YT = YT + K*VY

	MOVE.L	VZ1,D0
	ADDQ.L	#2,D6
	ASR.L	D6,D0
	ADD.L	D0,ZT1			* ZT = ZT + K*VZ

	MOVE.W	XT1,XT(A0)
	MOVE.W	YT1,YT(A0)
	MOVE.W	ZT1,ZT(A0)

	MOVE.W	VX1,VX(A0)		* CHANGE THIS LATER
	MOVE.W	VY1,VY(A0)		*      (FOR GUNS)	
	MOVE.W	VZ1,VZ(A0)

	CMP.L	#$400000,ZT1
	BGE	POS2

	CLR.L	VZ1			* ZERO VZ ON THE GROUND
	CLR.W	VZ(A0)
	MOVE.L	#$400000,ZT1		* Eye level 


POS2:	NOP
*-----------------------------------------------------------------------------
* Working set is in A0
* Primary Unit Vectors will be derived 

DISP	SET	UV2-UV1	  * The working set is always DISP below the working set

YWIND	
*	MOVE.W	CY(A0),D0
*	MULS	ASPD,D0
*	ASL.L	#2,D0
*	SWAP	D0
*--------
	MOVE.W	YP,D0		* 
*--------
	MULS	#$800,D0
	SWAP	D0		  

*YAW TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 79 MAX
* A0=Ship 2 primary
YW3	SUB.L	#DISP,A0
	JSR	T_YAW
	RTS
*-----------------------------------------------------------------------------
FLY4:	
* Crude Airplane Aerodynamics for Ship 2
* ROLL TIC
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 79 MAX
	MOVEA.W	#UV3,A0			*A0=Ship 1 primary
	MOVE.B	POT3,D0			*Roll Pot
	NEG.B	D0
	JSR	T_ROLL

* PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVEA.W	#UV3,A0			*A0=Ship 1 primary
	MOVE.B	POT2,D0			*Pitch Pot
	JSR	T_PTCH

* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
EFLY4:	MOVEA.W	#UV4,A0		*UV4 is the Working Set
	
* Thrust
	MOVE.W	#$3000,D1
	MULS	TSCALE,D1	
	ASL.L	#2,D1
	SWAP	D1		*D1 = scaled thrust

	MOVE.W	AX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* AX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FX2		* FX = THRUST*AX, MAX = 4000	

	MOVE.W	BX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* BX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FY2		* FY = THRUST*BX, MAX=4000
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* CX * THRUST, MAX = 1000 0000
	SWAP	D0
	MOVE.W	D0,FZ2		* FZ = THRUST*CX, MAX=4000	

*WING:	
	BSR	VCOM2

*	MOVE.W	XP,D0		* USE VXCOM FOR AIRSPEED
*	TST.W	D0
*	BPL	WNG2
*	NEG.W	D0
*WNG2	SUB.W	ASPD,D0
*	ASR.W	#3,D0
*	ADD.W	D0,ASPD		* ASPD = (NEW-OLD)/8 + OLD

	MOVE.W	ZP,D1		* D1= - VZCOMP = QW

	MOVE.W	AZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FX2		* FX = THRUST*AX + QW*AZ	

	MOVE.W	BZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FY2		* FY = THRUST*BX + QW*BZ	

	MOVE.W	CZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	SUB.W	GRAV,D0		
	ADD.W	D0,FZ2		* FZ = THRUST*CX + QW*CZ - GRAVITY

*FORCE:
	MOVE.W	FSHIFT,D6

	CLR.L	D0
	MOVE.W	FX2,D0
	SWAP	D0
	SUB.L	VX2,D0
	ASR.L	D6,D0
	ADD.L	D0,VX2		* VX = VX + (FX-VX)*K = VX + K*FX - K*VX

	CLR.L	D0
	MOVE.W	FY2,D0
	SWAP	D0
	SUB.L	VY2,D0
	ASR.L	D6,D0
	ADD.L	D0,VY2		* VY = VY + (FY-VY)*K = VY + K*FY - K*VY

	CLR.L	D0
	MOVE.W	FZ2,D0
	SWAP	D0
	SUB.L	VZ2,D0
	ASR.L	D6,D0
	ADD.L	D0,VZ2		* VZ = VZ + (FZ-VZ)*K = VZ + K*FZ - K*VZ

*Update the position
*POS:	
	MOVE.W	PSHIFT,D6

	MOVE.L	VX2,D0
	ASR.L	D6,D0
	ADD.L	D0,XT2			* XT = XT + K*VX

	MOVE.L	VY2,D0
	ASR.L	D6,D0
	ADD.L	D0,YT2			* YT = YT + K*VY

	MOVE.L	VZ2,D0
	ADDQ.L	#2,D6
	ASR.L	D6,D0
	ADD.L	D0,ZT2			* ZT = ZT + K*VZ

	MOVE.W	XT2,XT(A0)
	MOVE.W	YT2,YT(A0)
	MOVE.W	ZT2,ZT(A0)

	MOVE.W	VX2,VX(A0)		* CHANGE THIS LATER
	MOVE.W	VY2,VY(A0)		*      (FOR GUNS)	
	MOVE.W	VZ2,VZ(A0)

	CMP.L	#$400000,ZT2
	BGE	POS4

	CLR.L	VZ2			* ZERO VZ ON THE GROUND
	CLR.W	VZ(A0)
	MOVE.L	#$400000,ZT2		* Eye level 

POS4:	NOP
*-----------------------------------------------------------------------------
* Working set is in A0
* Primary Unit Vectors will be derived 

DISP	SET	UV2-UV1	  * The working set is always DISP below the working set

*YWIND	
*	MOVE.W	CY(A0),D0
*	MULS	ASPD,D0
*	ASL.L	#2,D0
*	SWAP	D0
*--------
	MOVE.W	YP,D0		* (TURNSC = $80)
*--------
	MULS	#$200,D0
	SWAP	D0		  

*YAW TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 79 MAX
* A0=Ship 2 primary
*YW3	
	SUB.L	#DISP,A0
	JSR	T_YAW
	RTS
*-----------------------------------------------------------------------------
	PAGE
* Calculate velocity components in the Ship's reference
* A0 points to Unit Vectors
* X component in XP, Y component in YP, Z component in ZP 
VCOM	MOVE.W	VX1,D1
	MULS	AX(A0),D1		*D1 = VX*AX

	MOVE.W	VY1,D0
	MULS	BX(A0),D0
	ADD.L	D0,D1			*D1 = VX*AX + VY*BX

	MOVE.W	VZ1,D0
	MULS	CX(A0),D0
	ADD.L	D0,D1			*D1 = VX*AX + VY*BX + VZ*CX

	ASL.L	#2,D1
	SWAP	D1			*D1 = VX*AX + VY*BX + VZ*CX
	NEG.W	D1

	MOVE.W	D1,XP			*XP = VXCOM = VX*AX + VY*BX + VZ*CX
*------------
	MOVE.W	VX1,D1
	MULS	AY(A0),D1		*D1 = VX*AY

	MOVE.W	VY1,D0
	MULS	BY(A0),D0
	ADD.L	D0,D1			*D1 = VX*AY + VY*BY

	MOVE.W	VZ1,D0
	MULS	CY(A0),D0
	ADD.L	D0,D1			*D1 = VX*AY + VY*BY + VZ*CY

	ASL.L	#2,D1
	SWAP	D1			*D1 = VX*AY + VY*BY + VZ*CY
	NEG.W	D1

	MOVE.W	D1,YP			*YP = VYCOM = VX*AY + VY*BY + VZ*CY
*------------
	MOVE.W	VX1,D1
	MULS	AZ(A0),D1		*D1 = VX*AZ

	MOVE.W	VY1,D0
	MULS	BZ(A0),D0
	ADD.L	D0,D1			*D1 = VX*AZ + VY*BZ

	MOVE.W	VZ1,D0
	MULS	CZ(A0),D0
	ADD.L	D0,D1			*D1 = VX*AZ + VY*BY + VZ*CZ

	ASL.L	#2,D1
	SWAP	D1			*D1 = VX*AZ + VY*BY + VZ*CZ
	NEG.W	D1

	MOVE.W	D1,ZP			*ZP = VZCOM = VX*AZ + VY*BY + VZ*CZ

	RTS

*-----------------------------------------------------------------------------
	PAGE
* Calculate velocity components in the Ship 2's reference
* A0 points to Unit Vectors
* X component in XP, Y component in YP, Z component in ZP 
VCOM2	MOVE.W	VX2,D1
	MULS	AX(A0),D1		*D1 = VX*AX

	MOVE.W	VY2,D0
	MULS	BX(A0),D0
	ADD.L	D0,D1			*D1 = VX*AX + VY*BX

	MOVE.W	VZ2,D0
	MULS	CX(A0),D0
	ADD.L	D0,D1			*D1 = VX*AX + VY*BX + VZ*CX

	ASL.L	#2,D1
	SWAP	D1			*D1 = VX*AX + VY*BX + VZ*CX
	NEG.W	D1

	MOVE.W	D1,XP			*XP = VXCOM = VX*AX + VY*BX + VZ*CX
*------------
	MOVE.W	VX2,D1
	MULS	AY(A0),D1		*D1 = VX*AY

	MOVE.W	VY2,D0
	MULS	BY(A0),D0
	ADD.L	D0,D1			*D1 = VX*AY + VY*BY

	MOVE.W	VZ2,D0
	MULS	CY(A0),D0
	ADD.L	D0,D1			*D1 = VX*AY + VY*BY + VZ*CY

	ASL.L	#2,D1
	SWAP	D1			*D1 = VX*AY + VY*BY + VZ*CY
	NEG.W	D1

	MOVE.W	D1,YP			*YP = VYCOM = VX*AY + VY*BY + VZ*CY
*------------
	MOVE.W	VX2,D1
	MULS	AZ(A0),D1		*D1 = VX*AZ

	MOVE.W	VY2,D0
	MULS	BZ(A0),D0
	ADD.L	D0,D1			*D1 = VX*AZ + VY*BZ

	MOVE.W	VZ2,D0
	MULS	CZ(A0),D0
	ADD.L	D0,D1			*D1 = VX*AZ + VY*BY + VZ*CZ

	ASL.L	#2,D1
	SWAP	D1			*D1 = VX*AZ + VY*BY + VZ*CZ
	NEG.W	D1

	MOVE.W	D1,ZP			*ZP = VZCOM = VX*AZ + VY*BY + VZ*CZ

	RTS
*===============================================================================
	PAGE
FLY5:
* KISS Airplane Aerodynamics for Ship 1
* PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVEA.W	#UV1,A0			* A0=Ship 1 primary
	
	MOVE.B	RPOT0,D0
	SUB.B	#$80,D0			* 80 max
	EXT.W	D0
	MULU	#$2C,D0			* 1600 max
	
	MOVE.W	CX(A0),D1		* 4000 max
	ASR.W	#1,D1			* 2000 max

	SUB.W	D1,D0			* error amplitude, 3600 max
	ASR.W	#8,D0			* 		   36 max

	JSR	T_PTCH

* ROLL TIC
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 79 MAX
	MOVEA.W	#UV1,A0			*A0=Ship 1 primary

	MOVE.B	RPOT1,D0
	SUB.B	#$80,D0			* 80 max
	EXT.W	D0
	MULU	#$2C,D0			* 1600 max

	MOVE.W	CY(A0),D1		* 4000 max
	ASR.W	#1,D1			* 2000 max

	ADD.W	D1,D0			* error amplitude, 3600 max
	ASR.W	#8,D0			* 		   36 max

	JSR	T_ROLL

* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
	MOVEA.W	#UV2,A0		*UV2 is the Working Set
	
* Thrust
	MOVE.W	THRUST(A0),D1
	MULS	TSCALE,D1	
	ASL.L	#2,D1
	SWAP	D1		*D1 = scaled thrust

	MOVE.W	AX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* AX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FX1		* FX = THRUST*AX, MAX = 4000	

	MOVE.W	BX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* BX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FY1		* FY = THRUST*BX, MAX=4000
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* CX * THRUST, MAX = 1000 0000
	SWAP	D0
	MOVE.W	D0,FZ1		* FZ = THRUST*CX, MAX=4000	

*WING	
	BSR	VCOM

	MOVE.W	XP,D0		* USE VXCOM FOR AIRSPEED
	TST.W	D0
	BPL	WNG2A
	NEG.W	D0
WNG2A	SUB.W	ASPD,D0
	ASR.W	#3,D0
	ADD.W	D0,ASPD		* ASPD = (NEW-OLD)/8 + OLD

	MOVE.W	ZP,D1		* D1= - VZCOMP = QW

	MOVE.W	AZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FX1		* FX = THRUST*AX + QW*AZ	

	MOVE.W	BZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FY1		* FY = THRUST*BX + QW*BZ	

	MOVE.W	CZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	SUB.W	GRAV,D0		
	ADD.W	D0,FZ1		* FZ = THRUST*CX + QW*CZ - GRAVITY

*FORCE:
	MOVE.W	FSHIFT,D6

	CLR.L	D0
	MOVE.W	FX1,D0
	SWAP	D0
	SUB.L	VX1,D0
	ASR.L	D6,D0
	ADD.L	D0,VX1		* VX = VX + (FX-VX)*K = VX + K*FX - K*VX

	CLR.L	D0
	MOVE.W	FY1,D0
	SWAP	D0
	SUB.L	VY1,D0
	ASR.L	D6,D0
	ADD.L	D0,VY1		* VY = VY + (FY-VY)*K = VY + K*FY - K*VY

	CLR.L	D0
	MOVE.W	FZ1,D0
	SWAP	D0
	SUB.L	VZ1,D0
	ASR.L	D6,D0
	ADD.L	D0,VZ1		* VZ = VZ + (FZ-VZ)*K = VZ + K*FZ - K*VZ

*Update the position
*POS	
	MOVE.W	PSHIFT,D6

	MOVE.L	VX1,D0
	ASR.L	D6,D0
	ADD.L	D0,XT1			* XT = XT + K*VX

	MOVE.L	VY1,D0
	ASR.L	D6,D0
	ADD.L	D0,YT1			* YT = YT + K*VY

	MOVE.L	VZ1,D0
	ADDQ.L	#2,D6
	ASR.L	D6,D0
	ADD.L	D0,ZT1			* ZT = ZT + K*VZ

	MOVE.W	XT1,XT(A0)
	MOVE.W	YT1,YT(A0)
	MOVE.W	ZT1,ZT(A0)

	MOVE.W	VX1,VX(A0)		* CHANGE THIS LATER
	MOVE.W	VY1,VY(A0)		*      (FOR GUNS)	
	MOVE.W	VZ1,VZ(A0)

	CMP.L	#$400000,ZT1
	BGE	POS2A

	CLR.L	VZ1			* ZERO VZ ON THE GROUND
	CLR.W	VZ(A0)
	MOVE.L	#$400000,ZT1		* Eye level 

POS2A:	
*-----------------------------------------------------------------------------
* Working set is in A0
* Primary Unit Vectors will be derived 

DISP	SET	UV2-UV1	  * The working set is always DISP below the working set

*YWIND	
*	MOVE.W	CY(A0),D0
*	MULS	ASPD,D0
*	ASL.L	#2,D0
*	SWAP	D0
*--------
	MOVE.W	UV2+CY,D0		* 
*--------
	MULS	#$30,D0
	SWAP	D0		  

*YAW TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 79 MAX
* A0=Ship 2 primary
*YW3	
	SUB.L	#DISP,A0
	JSR	T_YAW
	RTS
*===============================================================================
	PAGE
FLY6:
* KISS Rude and Crude for Ship 2
* PITCH TIC
* D0 CONTAINS DELTA ANGLE FOR PITCH, +/- 79 MAX
	MOVEA.W	#UV3,A0			* A0=Ship 2 primary
	
	MOVE.B	RPOT2,D0
	SUB.B	#$80,D0			* 80 max
	EXT.W	D0
	MULU	#$60,D0			* 1600 max (Dead Baron Control)
	
	MOVE.W	CX(A0),D1		* 4000 max
	ASR.W	#1,D1			* 2000 max

	SUB.W	D1,D0			* error amplitude, 3600 max
	ASR.W	#8,D0			* 		   36 max

	JSR	T_PTCH

* ROLL TIC
* D0 CONTAINS DELTA ANGLE FOR ROLL, +/- 79 MAX
	MOVEA.W	#UV3,A0			*A0=Ship 2 primary

	MOVE.B	RPOT3,D0
	SUB.B	#$80,D0			* 80 max
	NEG.B	D0
	EXT.W	D0
	MULU	#$60,D0			* 1600 max (Dead Baron Control)

	MOVE.W	CY(A0),D1		* 4000 max
	ASR.W	#1,D1			* 2000 max

	ADD.W	D1,D0			* error amplitude, 3600 max
	ASR.W	#8,D0			* 		   36 max

	JSR	T_ROLL

* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
	MOVEA.W	#UV4,A0		*UV4 is the Working Set
	
* Thrust
	MOVE.W	#$3000,D1
	MULS	TSCALE,D1	
	ASL.L	#2,D1
	SWAP	D1		*D1 = scaled thrust

	MOVE.W	AX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* AX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FX2		* FX = THRUST*AX, MAX = 4000	

	MOVE.W	BX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* BX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FY2		* FY = THRUST*BX, MAX=4000
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* CX * THRUST, MAX = 1000 0000
	SWAP	D0
	MOVE.W	D0,FZ2		* FZ = THRUST*CX, MAX=4000	

*WING:	
	BSR	VCOM2

*	MOVE.W	XP,D0		* USE VXCOM FOR AIRSPEED
*	TST.W	D0
*	BPL	WNG2
*	NEG.W	D0
*WNG2	SUB.W	ASPD,D0
*	ASR.W	#3,D0
*	ADD.W	D0,ASPD		* ASPD = (NEW-OLD)/8 + OLD

	MOVE.W	ZP,D1		* D1= - VZCOMP = QW

	MOVE.W	AZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FX2		* FX = THRUST*AX + QW*AZ	

	MOVE.W	BZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FY2		* FY = THRUST*BX + QW*BZ	

	MOVE.W	CZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	SUB.W	GRAV,D0		
	ADD.W	D0,FZ2		* FZ = THRUST*CX + QW*CZ - GRAVITY

*FORCE:
	MOVE.W	FSHIFT,D6

	CLR.L	D0
	MOVE.W	FX2,D0
	SWAP	D0
	SUB.L	VX2,D0
	ASR.L	D6,D0
	ADD.L	D0,VX2		* VX = VX + (FX-VX)*K = VX + K*FX - K*VX

	CLR.L	D0
	MOVE.W	FY2,D0
	SWAP	D0
	SUB.L	VY2,D0
	ASR.L	D6,D0
	ADD.L	D0,VY2		* VY = VY + (FY-VY)*K = VY + K*FY - K*VY

	CLR.L	D0
	MOVE.W	FZ2,D0
	SWAP	D0
	SUB.L	VZ2,D0
	ASR.L	D6,D0
	ADD.L	D0,VZ2		* VZ = VZ + (FZ-VZ)*K = VZ + K*FZ - K*VZ

*Update the position
*POS:	
	MOVE.W	PSHIFT,D6

	MOVE.L	VX2,D0
	ASR.L	D6,D0
	ADD.L	D0,XT2			* XT = XT + K*VX

	MOVE.L	VY2,D0
	ASR.L	D6,D0
	ADD.L	D0,YT2			* YT = YT + K*VY

	MOVE.L	VZ2,D0
	ADDQ.L	#2,D6
	ASR.L	D6,D0
	ADD.L	D0,ZT2			* ZT = ZT + K*VZ

	MOVE.W	XT2,XT(A0)
	MOVE.W	YT2,YT(A0)
	MOVE.W	ZT2,ZT(A0)

	MOVE.W	VX2,VX(A0)		* CHANGE THIS LATER
	MOVE.W	VY2,VY(A0)		*      (FOR GUNS)	
	MOVE.W	VZ2,VZ(A0)

	CMP.L	#$400000,ZT2
	BGE	POS4B

	CLR.L	VZ2			* ZERO VZ ON THE GROUND
	CLR.W	VZ(A0)
	MOVE.L	#$400000,ZT2		* Eye level 

POS4B:	
*-----------------------------------------------------------------------------
* Working set is in A0
* Primary Unit Vectors will be derived 

DISP	SET	UV2-UV1	  * The working set is always DISP below the working set

*YWIND	
*	MOVE.W	CY(A0),D0
*	MULS	ASPD,D0
*	ASL.L	#2,D0
*	SWAP	D0
*--------
	MOVE.W	UV4+CY,D0		* 
*--------
	MULS	#$30,D0
	SWAP	D0		  

*YAW TIC
* D0 CONTAINS DELTA ANGLE FOR YAW, +/- 79 MAX
* A0=Ship 2 primary
*YW3	
	SUB.L	#DISP,A0
	JSR	T_YAW
	RTS
*===============================================================================
	PAGE
S2CRASH:
* Crash Ship 2
* PITCH TIC
* Make it pitch down
	MOVEA.W	#UV3,A0			* A0=Ship 2 primary
	
	MOVE.W	#-$1600,D0		* Pitch target
	
	MOVE.W	CX(A0),D1		* 4000 max
	ASR.W	#1,D1			* 2000 max

	SUB.W	D1,D0			* error amplitude, 3600 max
	ASR.W	#8,D0			* 		   36 max

	JSR	T_PTCH

* ROLL TIC
	MOVEA.W	#UV3,A0			*A0=Ship 2 primary

	MOVE.W	#$1600,D0

	MOVE.W	CY(A0),D1		* 4000 max
	ASR.W	#1,D1			* 2000 max

	ADD.W	D1,D0			* error amplitude, 3600 max
	ASR.W	#8,D0			* 		   36 max

	JSR	T_ROLL

* Which way to fly?
	BTST	#4,INPUTS+1
	BEQ	S2C1
*FLY2 MODE

	MOVEA.W	#UV4,A0		*UV4 is the Working Set for Ship 2

* A0 points to ship's working vectors
* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
	MOVE.W	THRUST(A0),D1
	ASR.W	#1,D1		*D1 = scaled thrust = 2000 max

	MOVE.W	AX(A0),D0
	MULS	D1,D0		* AX * THRUST, MAX = 1000 0000
	ASL.L	#2,D0		* MAX = 2000 0000
	SUB.L	VX(A0),D0
	ASR.L	#5,D0		
	ADD.L	D0,VX(A0)	* VX = OLD + (NEW-OLD)/32	

	MOVE.W	BX(A0),D0
	MULS	D1,D0		* BX * THRUST, MAX = 1000 0000
	ASL.L	#2,D0		* MAX = 2000 0000
	SUB.L	VY(A0),D0
	ASR.L	#5,D0		
	ADD.L	D0,VY(A0)	* VY = OLD + (NEW-OLD)/32	
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0		* CX * THRUST, MAX = 1000 0000
	ASL.L	#2,D0		* MAX = 2000 0000
	SUB.L	VZ(A0),D0
	ASR.L	#5,D0		
	ADD.L	D0,VZ(A0)	* VZ = OLD + (NEW-OLD)/32	
*----------------
* UPOS Update the position 
	MOVE.W	VX(A0),D0
	ASR.W	#8,D0			* K * VX
	ADD.W	D0,XT(A0)		* XT = XT + K*VX

	MOVE.W	VY(A0),D0
	ASR.W	#8,D0			* K * VY
	ADD.W	D0,YT(A0)		* YT = YT + K*VY

	MOVE.W	VZ(A0),D0
	ASR.W	#8,D0			* K * VZ
	ADD.W	D0,ZT(A0)		* ZT = ZT + K*VZ

	CMP.W	#00,ZT(A0)
	BGE	POS4C

	CLR.W	VX(A0)
	CLR.W	VY(A0)
	CLR.L	VZ(A0)			* 

	MOVE.W	#$00,ZT(A0)		

POS4C	RTS

* FLY6 MODE

S2C1	

* Calculate Force due to Thrust. Distribute thrust along (AX,BX,CX)
	MOVEA.W	#UV4,A0		*UV4 is the Working Set
	
* Thrust
	MOVE.W	#$3000,D1
	MULS	TSCALE,D1	
	ASL.L	#2,D1
	SWAP	D1		*D1 = scaled thrust

	MOVE.W	AX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* AX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FX2		* FX = THRUST*AX, MAX = 4000	

	MOVE.W	BX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* BX * THRUST, MAX = 4000 0000
	SWAP	D0
	MOVE.W	D0,FY2		* FY = THRUST*BX, MAX=4000
	
	MOVE.W	CX(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0		* CX * THRUST, MAX = 1000 0000
	SWAP	D0
	MOVE.W	D0,FZ2		* FZ = THRUST*CX, MAX=4000	

*WING:	
	BSR	VCOM2

	MOVE.W	ZP,D1		* D1= - VZCOMP = QW

	MOVE.W	AZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FX2		* FX = THRUST*AX + QW*AZ	

	MOVE.W	BZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	ADD.W	D0,FY2		* FY = THRUST*BX + QW*BZ	

	MOVE.W	CZ(A0),D0
	MULS	D1,D0
	ASL.L	#2,D0
	SWAP	D0
	ASL.W	#1,D0
	SUB.W	GRAV,D0		
	ADD.W	D0,FZ2		* FZ = THRUST*CX + QW*CZ - GRAVITY

*FORCE:
	MOVE.W	FSHIFT,D6

	CLR.L	D0
	MOVE.W	FX2,D0
	SWAP	D0
	SUB.L	VX2,D0
	ASR.L	D6,D0
	ADD.L	D0,VX2		* VX = VX + (FX-VX)*K = VX + K*FX - K*VX

	CLR.L	D0
	MOVE.W	FY2,D0
	SWAP	D0
	SUB.L	VY2,D0
	ASR.L	D6,D0
	ADD.L	D0,VY2		* VY = VY + (FY-VY)*K = VY + K*FY - K*VY

	CLR.L	D0
	MOVE.W	FZ2,D0
	SWAP	D0
	SUB.L	VZ2,D0
	ASR.L	D6,D0
	ADD.L	D0,VZ2		* VZ = VZ + (FZ-VZ)*K = VZ + K*FZ - K*VZ

*Update the position
*POS:	
	MOVE.W	PSHIFT,D6

	MOVE.L	VX2,D0
	ASR.L	D6,D0
	ADD.L	D0,XT2			* XT = XT + K*VX

	MOVE.L	VY2,D0
	ASR.L	D6,D0
	ADD.L	D0,YT2			* YT = YT + K*VY

	MOVE.L	VZ2,D0
	ADDQ.L	#2,D6
	ASR.L	D6,D0
	ADD.L	D0,ZT2			* ZT = ZT + K*VZ

	MOVE.W	XT2,XT(A0)
	MOVE.W	YT2,YT(A0)
	MOVE.W	ZT2,ZT(A0)

	MOVE.W	VX2,VX(A0)		* CHANGE THIS LATER
	MOVE.W	VY2,VY(A0)		*      (FOR GUNS)	
	MOVE.W	VZ2,VZ(A0)

	CMP.W	#$0000,ZT2
	BGE	POS4D

	CLR.L	VX2
	CLR.L	VY2
	CLR.L	VZ2			* ZERO VZ ON THE GROUND
	CLR.W	VZ(A0)

	MOVE.L	#$0000,ZT2		* Eye level 

POS4D:	RTS

*===============================================================================
	END
;******************************************************************************
;AERODYNAMICS:
;
;	Indicated Airspeed (as measured by a Pitot tube) is the component
;	of velocity along the aircraft's X direction.
;
;	Parasitic Drag is opposite the velocity vector.
;	Parasitic Drag will be proportional to Velocity (instead of squared).
;	
;	Gravity is down.
;
;	For an Airplane:
;		Thrust is along (AX,BX,CX)
;	
;		The component of wind normal to the wing is
;		QW = (-VX*AZ -VY*BZ -VZ*CZ)
;
;		The force on the Wing is along (AZ,BZ,CZ)
;
;
;	AERO:
;		VELOCITY (FORCE) NORMAL TO THE WING: QW = -VX*AZ -VY*BZ -VZ*CZ
;
;		FX = THRUST*AX + PDR*VX + QW*AZ
;
;		FY = THRUST*BX + PDR*VY + QW*BZ
;
;		FZ = THRUST*CX + PDR*VZ + QW*CZ + GRAVITY
;
;
;	For a Helicopter:
;		Thrust is along (AZ,BZ,CZ)
;
;		Treat the Rotor as a wing
;
;
;	Update:	VX = VX + K1*FX
;		VY = VY + K1*FY
;		VZ = VZ + K1 FZ
;
;		XT = XT + K2*VX
;		YT = YT + K2*VY
;		ZT = ZT + K2*VZ
;
;
; QW (AZ, BZ, CZ) represents the force due to the plane's angle of attack 
; (the angle that the relative wind makes to the wing [chord]. In this model 
; the relative wind is due entirely to the plane's velocity. Normally this 
; force (which produces lift and drag) is proportional to the square of the 
; velocity. Here it is linearly proportional to the velocity.
;
; Parasitic Drag is proportional to the square of the speed, but in this model 
; will be linear.
;	
; Lift and Drag is just a way of saying that if you look at the force 
; produced on the wing, (and you are flying right-side-up with a reasonable 
; angle of attack), the force will have a component opposite gravity (lift) 
; and a component opposite the Plane's [straight ahead] motion (drag).
;
; If the Wings are not level, there will also be a component to the side, 
; which by itself would produce side slip. However, the Tail acts as a 
; weathercock to turn the Nose into the [relative] wind. This is why an 
; airplane banks and doesn't just slip to the side. 
;
;SCALING:
;	When multiplying, 4000 * 4000 = 1000 0000 which is then shifted right 
;	14 times to get 4000.
;
;	Scaling is keyed to V Max (VX, VY or VZ).
;	
;	V Max is 4000.
;
;	Therefore QW Max is 4000 . This would only occur if VX is 4000
;	and the pilot pitches instantaneously 90 degrees, which is
;	unlikely but possible.
;
;	QW*AZ, QW*BZ, QW*CZ - maximum value is ~ 2000. (0800 0000)
;
; Thrust and Parasitic Drag are scaled relative to QW.

********************************************************************************
