	TTL 'MACRO DRAWING ROUTINES'


	INCLUDE 'COMN.ASM'

	XDEF	D_CUBE,D_SQ,D_TANK,D_ROC,D_AIR,D_SAU,D_CITY,D_HIND,D_HROT,DEND
*	XDEF	D_CUBE,D_SQ,D_TANK,D_ROC,D_AIR,D_SAU,DEND,D_CITY
	XDEF	D2_CUBE,D2_SQ,D2_TANK,D2_ROC,D2_AIR,D2_SAU,D2_CITY
	XDEF	D2_HIND,D2_HROT

	SECTION PROGRAM

******************************** Drawing Macros ********************************
* Uses 	A0 = VG address pointer
* 	D0 = temporary data
*	D1 = temporary data  (#$ 0000 60000 = VCTR 0,0,6) 
*
*Format: COLOR COLOR,ZSCALE
COLOR	MACRO	
	MOVE.W	#($6000!((\1&$7)*$100)!(\2&$0FF)),(A0)+
	ENDM

*Format: SCAL BIN,LIN
SCAL	MACRO
	MOVE.W	#($7000!((\1&$7)*$100)!(\2&$0FF)),(A0)+
	ENDM

CENTER	MACRO	
	MOVE.W	#$8040,(A0)+	* CENTER COMMAND and increment pointer
	ENDM

VGHALT	MACRO
	MOVE.W	#$2000,(A0)+	* VGHALT and increment pointer
	ENDM

STAT	MACRO
	MOVE.B	COLOR,D0
	AND.B	#$07,D0		*COLOR IS LOW THREE BITS
	OR.B	#$60,D0		*COLOR STAT INSTRUCTION
	LSL.W	#8,D0
	OR.B	ZSTAT,D0
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
	ENDM

*PLOTC n -  First point after CENTER:
PLOTC	MACRO
	MOVE.W	\1*4+Y(A1),D0		
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer

	MOVE.W	\1*4+X(A1),D0
	AND.W	#$1FFF,D0	* BRITE = OFF		[X]
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
LASTX	SET	\1*4+X
LASTY	SET	\1*4+Y


	ENDM

*DRAWTO m
DRAWTO	MACRO
	MOVE.W	\1*4+Y(A1),D0		
	SUB.W	LASTY(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	\1*4+X(A1),D0
	SUB.W	LASTX(A1),D0
	OR.W	#$E000,D0	* BRITE = ON		[X]
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
LASTX	SET	\1*4+X
LASTY	SET	\1*4+Y


	ENDM

*PLOT m
PLOT	MACRO
	MOVE.W	\1*4+Y(A1),D0		
	SUB.W	LASTY(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	\1*4+X(A1),D0
	SUB.W	LASTX(A1),D0
	AND.W	#$1FFF,D0	* BRITE = OFF
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
LASTX	SET	\1*4+X
LASTY	SET	\1*4+Y


	ENDM

* DOT
*Draw a dot  (D1 must be initialised to $00006000 by the routine that wants 
*to use DOT)
DOT	MACRO		

	MOVE.L	D1,(A0)+

	ENDM	
********************************************************************************
OFF	EQU	$0
BLUE	EQU	$1
GREEN	EQU	$2
TURQ	EQU	$3
RED	EQU	$4
PURPLE	EQU	$5
YELLOW	EQU	$6
WHITE	EQU	$7

	PAGE
* Draw the Cube
D_CUBE:	
	MOVEA.W	#PTBL,A1

D2_CUBE:
	MOVEA.L	VG_PTR,A0

	SCAL	2,0
	COLOR	RED,$40
*	MOVE.W 	#$7200,(A0)+	*SCALE BIN=2, LIN=00
*	MOVE.W 	#$6720,(A0)+	*COLOR WHITE, ZSTAT=20

	PLOTC 0
	DRAWTO 1
	DRAWTO 2
	DRAWTO 3
	DRAWTO 0
	DRAWTO 4
	DRAWTO 5
	DRAWTO 1
	DRAWTO 5
	DRAWTO 6
	DRAWTO 2
	DRAWTO 6
	DRAWTO 7
	DRAWTO 3
	DRAWTO 7
	DRAWTO 4
  	CENTER

  	MOVE.L	A0,VG_PTR	

	RTS 	

* Draw the City
D_CITY:	
	MOVEA.W	#PTBL,A1

D2_CITY:
	MOVEA.L	VG_PTR,A0

	SCAL	2,0
	COLOR	RED,$40

	MOVE.L	#$00006000,D1		* = [VCTR 0,0,6]
	PLOTC 0
	DOT
	PLOT 1
	DOT
	PLOT 2
	DOT
	PLOT 3
	DOT
	PLOT 4
	DOT
	PLOT 5
	DOT
	PLOT 6
	DOT
	PLOT 7
	DOT

  	CENTER

  	MOVE.L	A0,VG_PTR	

	RTS 	

* Draw the Square
D_SQ:
	MOVEA.W	#PTBL,A1

D2_SQ:
	MOVEA.L	VG_PTR,A0

	SCAL	2,0
	COLOR	RED,$40
*	MOVE.W 	#$7200,(A0)+	*SCALE BIN=2, LIN=00
*	MOVE.W 	#$6420,(A0)+	*COLOR RED, ZSTAT=20

 	CENTER	

  	PLOTC 0
	DRAWTO 1
	DRAWTO 2
	DRAWTO 3
	DRAWTO 0
  	CENTER

	MOVE.L	A0,VG_PTR
	RTS		

	PAGE
* Draw the Tank
D_TANK:	
	MOVEA.W	#PTBL,A1

D2_TANK:	
	MOVEA.L	VG_PTR,A0

	SCAL	2,0
	COLOR	WHITE,$40
*	MOVE.W 	#$7200,(A0)+	*SCALE BIN=1, LIN=80
*	MOVE.W 	#$6720,(A0)+	*COLOR WHITE, ZSTAT=20

  	PLOTC 23
	DRAWTO 22
  	PLOT   12
	DRAWTO 13
  	PLOT   14
	DRAWTO 20
	DRAWTO 18
	DRAWTO 15
	DRAWTO 14
	DRAWTO 17
	DRAWTO 16
	DRAWTO 19
	DRAWTO 21
	DRAWTO 17 
  	PLOT   15
	DRAWTO 16
  	PLOT   19
	DRAWTO 18
  	PLOT   20
	DRAWTO 21
  	PLOT   3
	DRAWTO 0
	DRAWTO 4
	DRAWTO 7
	DRAWTO 6
	DRAWTO 2
	DRAWTO 3
	DRAWTO 7
	DRAWTO 11
	DRAWTO 10
	DRAWTO 6
	DRAWTO 5
	DRAWTO 9
	DRAWTO 10
	DRAWTO 13
	DRAWTO 9
	DRAWTO 8
	DRAWTO 11
	DRAWTO 12
	DRAWTO 8
	DRAWTO 4
	DRAWTO 5
	DRAWTO 1
	DRAWTO 2
	PLOT   1
	DRAWTO 0

  	CENTER		

	MOVE.L	A0,VG_PTR

	RTS	
	PAGE
* Draw the Rocket Ship
D_ROC:	
	MOVEA.W	#PTBL,A1

D2_ROC:	
	MOVEA.L	VG_PTR,A0	

	SCAL	2,0

	TST.B	GLOW
	BEQ	DR1
	MOVE.W	#$6480,(A0)+
	SUBQ.B	#1,GLOW
	BRA	DR2

DR1	MOVE.W	#$6700,D0
	MOVE.B	BRITE,D0
	MOVE.W	D0,(A0)+

DR2	PLOTC 5
	DRAWTO 0
	DRAWTO 6
	DRAWTO 7
	DRAWTO 0
	DRAWTO 8
	DRAWTO 10
	DRAWTO 0
	DRAWTO 9
	DRAWTO 5		
	PLOT   1 
	DRAWTO 2
	DRAWTO 3
	DRAWTO 4				
	PLOT   8 
	DRAWTO 7
	DRAWTO 23
	DRAWTO 20
	DRAWTO 8			
	DRAWTO 12
	DRAWTO 18
	DRAWTO 20
	DRAWTO 24
	DRAWTO 18				
	PLOT   12 
	DRAWTO 10				
	PLOT   5
	DRAWTO 6
	DRAWTO 21
	DRAWTO 19
	DRAWTO 5			
	DRAWTO 11
	DRAWTO 17
	DRAWTO 19
	DRAWTO 22
	DRAWTO 17				
	PLOT   11 
	DRAWTO 9
	DRAWTO 22
	DRAWTO 21
	DRAWTO 16
	DRAWTO 13
	DRAWTO 14
	DRAWTO 15		
	DRAWTO 16
	DRAWTO 23
	DRAWTO 24
	DRAWTO 22				
	PLOT   24 
	DRAWTO 10
	DRAWTO 9				
	CENTER	

	MOVE.L	A0,VG_PTR	

	RTS	

	PAGE
*Draw the Airplane
D_AIR	
	MOVEA.W	#PTBL,A1

D2_AIR	
	MOVEA.L	VG_PTR,A0

	SCAL	2,0
	COLOR	WHITE,$40
*	MOVE.W 	#$7200,(A0)+	*SCALE BIN=2, LIN=00
*	MOVE.W 	#$6720,(A0)+	*COLOR WHITE, ZSTAT=20

	PLOTC 5 
	DRAWTO 1
	DRAWTO 0
	DRAWTO 4
	DRAWTO 8			
	DRAWTO 0
	DRAWTO 2
	DRAWTO 3
	DRAWTO 1
	DRAWTO 6
	DRAWTO 5				
	PLOT   13 
	DRAWTO 12
	DRAWTO 11
	DRAWTO 10			
	PLOT   4 
	DRAWTO 21
	DRAWTO 22
	DRAWTO 23
	DRAWTO 4
	DRAWTO 9
	DRAWTO 2			
	PLOT   3 
	DRAWTO 7
	DRAWTO 5
	DRAWTO 16
	DRAWTO 15
	DRAWTO 14
	DRAWTO 5			
	PLOT   19 
	DRAWTO 6
	DRAWTO 8
	DRAWTO 17
	DRAWTO 19
	DRAWTO 14
	DRAWTO 23
	DRAWTO 17		
	PLOT   23 
	DRAWTO 18
	DRAWTO 22				
	PLOT   21 
	DRAWTO 9
	DRAWTO 18
	DRAWTO 20
	DRAWTO 15			
	PLOT   16 
	DRAWTO 7
	DRAWTO 9				
	PLOT   7 
	DRAWTO 20
	DRAWTO 14				

	CENTER	

	MOVE.L	A0,VG_PTR	

	RTS	
	
	PAGE
* Draw the Flying Saucer
D_SAU	
	MOVEA.W	#PTBL,A1
D2_SAU	
	MOVEA.L	VG_PTR,A0	

	SCAL	2,0
	COLOR	WHITE,$40
*	MOVE.W 	#$7200,(A0)+	*SCALE BIN=2, LIN=00
*	MOVE.W 	#$6720,(A0)+	*COLOR WHITE, ZSTAT=20

	PLOTC 16 
	DRAWTO 8
	DRAWTO 9
	DRAWTO 16
	DRAWTO 10
	DRAWTO 11
	DRAWTO 16
	DRAWTO 12
	DRAWTO 13		
	DRAWTO 16
	DRAWTO 14
	DRAWTO 15
	DRAWTO 16				
	PLOT   0 
	DRAWTO 7
	DRAWTO 15
	DRAWTO 8
	DRAWTO 0
	DRAWTO 1
	DRAWTO 9
	DRAWTO 10
	DRAWTO 2
	DRAWTO 3		
	DRAWTO 11
	DRAWTO 12
	DRAWTO 4
	DRAWTO 5
	DRAWTO 13
	DRAWTO 14
	DRAWTO 6
	DRAWTO 7			
	PLOT   6 
	DRAWTO 5				
	PLOT   4 
	DRAWTO 3				
	PLOT   2 
	DRAWTO 1				

	CENTER

	MOVE.L	A0,VG_PTR	

	RTS	
		
	PAGE
* Draw the Hind (Russian Helicopter)
*
*Draw HIND body

D_HIND	
	MOVEA.W	#PTBL,A1
D2_HIND	
	MOVEA.L	VG_PTR,A0	

	SCAL	2,0
	COLOR	RED,$40

	PLOTC 3 
	DRAWTO 5 
	DRAWTO 1 
	DRAWTO 0 
	DRAWTO 4 
	DRAWTO 2			
	DRAWTO 8 
	DRAWTO 9 
	DRAWTO 7 
	DRAWTO 6 
	DRAWTO 8				
	PLOT   9 
	DRAWTO 3				
	PLOT   5 
	DRAWTO 7 
	DRAWTO 1				
	PLOT   0 
	DRAWTO 6 
	DRAWTO 4				
	PLOT   6 
	DRAWTO 10 
	DRAWTO 11 
	DRAWTO 7			
	PLOT   9 
	DRAWTO 21 
	DRAWTO 20 
	DRAWTO 8			
	PLOT   13 
	DRAWTO 12 
	DRAWTO 18 
	DRAWTO 19			
	PLOT   17 
	DRAWTO 16 
	DRAWTO 15 
	DRAWTO 14			
	PLOT   11 
	DRAWTO 23 
	DRAWTO 25 
	DRAWTO 21 
	DRAWTO 20 
	DRAWTO 24		
	DRAWTO 22 
	DRAWTO 10				
	PLOT   20 
	DRAWTO 21				
	PLOT   23 
	DRAWTO 22				
	PLOT   24 
	DRAWTO 25				
	PLOT   26 
	DRAWTO 28 
	DRAWTO 34 
	DRAWTO 42 
	DRAWTO 40 
	DRAWTO 38 
	DRAWTO 36		
	DRAWTO 30 
	DRAWTO 32 
	DRAWTO 26 
	DRAWTO 27
	DRAWTO 29 
	DRAWTO 35 
	DRAWTO 43		
	DRAWTO 41 
	DRAWTO 39 
	DRAWTO 37 
	DRAWTO 31 
	DRAWTO 33 
	DRAWTO 27			
	PLOT   29 
	DRAWTO 28				
	PLOT   34 
	DRAWTO 35				
	PLOT   31 
	DRAWTO 30				
	PLOT   36 
	DRAWTO 37				
	PLOT   39 
	DRAWTO 38				
	PLOT   40 
	DRAWTO 32 
	DRAWTO 33 
	DRAWTO 41			
	PLOT   53 
	DRAWTO 48 
	DRAWTO 49 
	DRAWTO 50 
	DRAWTO 51 
	DRAWTO 53		
	PLOT   52 
	DRAWTO 44 
	DRAWTO 45 
	DRAWTO 46 
	DRAWTO 47			
	PLOT   42 
	DRAWTO 43				
	PLOT   33 
	DRAWTO 35				
	PLOT   34 
	DRAWTO 32				

	CENTER

	MOVE.L	A0,VG_PTR	

	RTS

	PAGE

* Draw the Helicopter Rotors
D_HROT	
	MOVEA.W	#PTBL,A1
D2_HROT	
	MOVEA.L	VG_PTR,A0	

	SCAL	2,0
	COLOR	RED,$40

	PLOTC 0
	DRAWTO 1 
	DRAWTO 2 
	DRAWTO 3 
	DRAWTO 0 
	DRAWTO 4 
	DRAWTO 5		
	DRAWTO 6 
	DRAWTO 7 
	DRAWTO 4				
	PLOT   8 
	DRAWTO 9 
	DRAWTO 10 
	DRAWTO 8 
	DRAWTO 15 
	DRAWTO 16 
	DRAWTO 8			
	DRAWTO 13 
	DRAWTO 14 
	DRAWTO 8 
	DRAWTO 11 
	DRAWTO 12 
	DRAWTO 8			
	PLOT   1
	DRAWTO 5				
	PLOT   7 
	DRAWTO 3				
	PLOT   2 
	DRAWTO 6				

	CENTER

	MOVE.L	A0,VG_PTR

	RTS	

DEND	END
