	TTL 'MATH2'

	XREF PRESUB,POST2,TPROJ,S2CRASH,DRDOTS
	XREF D_CITY,D_TANK,D_CUBE,CITY,CUBE,TANK


	INCLUDE 'COMN.ASM'

	XDEF TERR,TERR1,TERR2,TERR3,TERR4,TERRB
	XDEF LTLOC,LTS,LIGHTS,LT2,LT3,LT4,LT5,LT6,LT7,LT8
	XDEF VASILOC,VASI,VLIGHTS,VLT2,VLT3,VLT4,VLT5,VLT6,VLT7,VLT8
	XDEF PDOT
	XDEF GUNLP,GUNLP2,GUNLP4,GLT2,GLT3,GLT4,GLT5,GLT6,GLT7,GLT8
	XDEF GUNS,DGUNS,TRIG,GHITS,GH1,GH2,GUNUP,FIRE
	PAGE	

	SECTION PROGRAM

*Do Terrain Objects
*	JSR	TERR

* Do the VASI Lights
*	JSR	VASI

* Do other lights
*	JSR	LIGHTS

* Do the Guns
*	JSR	GUNS


	PAGE
* Lights
* Light Location
LTLOC:	
	DC.W	-$800,0,0
	DC.W	-$600,0,0
	DC.W	-$400,0,0
	DC.W	-$200,0,0
	DC.W	    0,0,0	

LIGHTS:
	ADD.B	#$18,STRBTIME	*STRBTIME times each strobe 
	BPL	LTS2		* Do the current strobe

	CLR.B	STRBTIME
	ADDQ.B	#1,STRBNUM	*STRBNUM, 0 - 4 indicates a strobe light
	CMP.B	#9,STRBNUM	*	  5 - 9 indicates all strobes off
	BLT	LTS1
	CLR.B	STRBNUM
LTS1 	RTS

LTS2 	CMP.B	#4,STRBNUM
	BLE	LTS3
	RTS

LTS3 	MOVEA.W #UV2,A0		* The Observer
	MOVEA.L	#LTLOC,A1	* Light Location
	CLR.L	D0
	MOVE.B	STRBNUM,D0
	MULU	#6,D0
	ADD.L	D0,A1		* A1 points to the correct strobe light

	BSR	LTS

	RTS

LTS:
*Is it within the allowable radius?
	MOVE.W	X(A1),D1
	SUB.W	XT(A0),D1	
LT1	MULS	D1,D1		D1=(X-XT)**2

	MOVE.W	Y(A1),D0
	SUB.W	YT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2

	MOVE.W	Z(A1),D0
	SUB.W	ZT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2 + (Z-ZT)**2

	CMP.L	#$31000000,D1
	BLE	LT2		*If it is too far,don't draw it
	RTS
LT2	CMP.L	#$100,D1	
	BGE	LT3		*If too close, don't draw it
	RTS

LT3	JSR	PRESUB		* look at it

* Light is at XP,YP,ZP
* Check to see if it is visible.
	MOVE.W	XP,D0
	CMP.W	#$80,D0
	BGT	LT4
	RTS			* XP cannot be negative

LT4	MOVE.W	YP,D1
	EXT.L	D1
	BPL	LT5
	NEG.W	D1
LT5	CMP.W	D0,D1
	BLE	LT6
	RTS
* ABS(YP) .LE. XP
LT6	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	LT7
	NEG.W	D2
LT7	CMP.W	D0,D2
	BLE	LT8
	RTS

* ABS(ZP) .LE XP

LT8	MOVE.W	#$67A0,STAT	* White

* Project the Light at (XP,YP,ZP) and draw a dot
	BSR	PDOT
	RTS

	PAGE
*-------------------------------------------------------------------------------
*VASI Lights
* VASI Lights Location
VASILOC: DC.W	$800,$300,0	
	 DC.W	$800,-$300,0
VASI:
	MOVEA.W #UV2,A0		* The Observer
	MOVEA.L	#VASILOC,A1	* VASI Light #1
	BSR	VLIGHTS

	MOVEA.W #UV2,A0		* The Observer
	MOVEA.L	#VASILOC+6,A1	* VASI Light #2
	BSR	VLIGHTS		* Do it

	RTS

VLIGHTS:

*Is it within the allowable radius?
	MOVE.W	X(A1),D1
	SUB.W	XT(A0),D1	
VLT1	MULS	D1,D1		D1=(X-XT)**2

	MOVE.W	Y(A1),D0
	SUB.W	YT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2

	MOVE.W	Z(A1),D0
	SUB.W	ZT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2 + (Z-ZT)**2

	CMP.L	#$31000000,D1
	BLE	VLT2		*If it is too far, don't draw it
	RTS
VLT2	CMP.L	#$100,D1	
	BGE	VLT3		*If too close, don't draw it
	RTS

VLT3	JSR	PRESUB		* look at it

* Light is at XP,YP,ZP
* Check to see if it is visible.
	MOVE.W	XP,D0
	CMP.W	#$80,D0
	BGT	VLT4
	RTS			* XP cannot be negative

VLT4	MOVE.W	YP,D1
	EXT.L	D1
	BPL	VLT5
	NEG.W	D1
VLT5	CMP.W	D0,D1
	BLE	VLT6
	RTS
* ABS(YP) .LE. XP
VLT6	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	VLT7
	NEG.W	D2
VLT7	CMP.W	D0,D2
	BLE	VLT8
	RTS

* ABS(ZP) .LE XP

* ATAN (1/8) = 7.13 degrees
* ATAN (1/32 + 1/8) = 8.88 degrees


* ATAN (1/16) = 3.58 degrees
* ATAN (1/16 + 1/64) = 4.47 degrees

* The color of the lights is based on glide slope in the absolute Universe
VLT8	MOVE.W	X(A1),D0
	SUB.W	XT(A0),D0	* D0 = DX = (X-XT)
	BPL	VLT8a		
	RTS			* lights are only visible from runway approach

VLT8a	MOVE.W	ZT(A0),D1
	SUB.W	Z(A1),D1	* D1 = DZ = (ZT-Z)
	BPL	VLT8b
	RTS			* lights are only visible from on top	

VLT8b	ASR.W	#3,D0		* D0 = DX*(1/8) = (0.125 * DX)
	MOVE.W 	D0,D2		* D2 = DX*(1/8)
	ASR.W	#2,D2		* D2 = DX*(1/32)
	ADD.W	D0,D2		* D2 = DX*(1/8 + 1/32) = (0.156 * DX)

	CMP.W	D2,D1		* (ZP - 0.156 DX)
	BLT	VLT9		
	MOVE.W	#$6180,STAT	* Blue above angle of 8.88 degrees
	BRA	VLT11
*Less than 8.88 degrees
VLT9	CMP.W	D0,D1		* (ZP - 0.125 DX)
	BLT	VLT10
* Between 7.13 and 8.88 degrees
	MOVE.W	#$6780,STAT	* White between 7.13 and 8.88 degrees
	BRA	VLT11
* Less than 7.13 degrees
VLT10	MOVE.W	#$6480,STAT

* Project the Light at (XP,YP,ZP) and draw a dot
VLT11	BSR	PDOT
	RTS
*-------------------------------------------------------------------------------
	PAGE
*TERRAIN OBJECT LOCATIONS
TERLOC:	DC.W	$6000,0,0	
	DC.W	0,$6000,0	
	DC.W	-$6000,0,0
	DC.W	0,-$6000,0
	DC.W	$5322,$3000,0
	DC.W	$3000,$5322,0
	DC.W	-$5322,$3000,0
	DC.W	-$3000,$5322,0
	DC.W	-$5322,-$3000,0
	DC.W	-$3000,-$5322,0
	DC.W	$5322,-$3000,0
	DC.W	$3000,-$5322,0
	DC.W	$3000,$3000,0
	DC.W	-$3000,$3000,0
	DC.W	-$3000,-$3000,0
	DC.W	$3000,-$3000,0


*Terrain Objects
TERR:	BRA	TERRB	
*Rotate the Terrain Object
*Select the Terrain Object
*	CLR.W	LED1ON	
	MOVEA.W	#UV2,A0
	LEA.L	CITY,A4		*Terrain Object is a City
*	LEA.L	CUBE,A4		*Terrain Object is a Cube
*	LEA.L	TANK,A4		*Terrain Object is a Tank
	MOVEA.W	#TOBJ,A5	*Output is Terrain Object Point Table
	MOVE.L	#8,D5		* A Cube (or city) has 8 points
*	MOVE.L	#24,D5		* A Tank has 24 points
	JSR	POST2	
*	CLR.W	LED1OFF	
*Rotated Terrain Object is now in TOBJ

*Translate and project the rotated Terrain Object
	LEA.L	TERLOC,A1
	MOVE.L	A1,T_PTR
	MOVE.W	#16,T_CNT	*Do 12 Terrain Objects
TERR1	
*	CLR.W	LED2ON
	MOVE.L	T_PTR,A1
	MOVEA.W	#UV2,A0
*--------------------------------------------------------------------
*Is it within the allowable radius?
	MOVE.W	X(A1),D1
	SUB.W	XT(A0),D1
	MULS	D1,D1		D1=(X-XT)**2

	MOVE.W	Y(A1),D0
	SUB.W	YT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2

	MOVE.W	Z(A1),D0
	SUB.W	ZT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2 + (Z-ZT)**2

* $3000 0000 (unadjusted) seems to be a good allowable radius.
	CMP.L	#$30000000,D1
	BGT	TERR4			*If it is greater, don't draw it
*--------------------------------------------------------------------
	JSR	PRESUB		*Does one point
*	CLR.W	LED2OFF
* Object center point is at XP,YP,ZP
* Check to see if the object is visible.
	MOVE.W	XP,D0
	CMP.W	#$200,D0
	BLT	TERR4		
*(XP .GE. $100)
	MOVE.W	YP,D1
	EXT.L	D1
	BPL	TERR2
	NEG.W	D1
TERR2	CMP.W	D0,D1
	BGT	TERR4
*ABS(YP) .LE. XP
	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	TERR3
	NEG.W	D2
TERR3	CMP.W	D0,D2
	BGT	TERR4
*ABS(ZP) .LE XP
*Translate the terrain object to XP,YP,ZP and Project it.
*	CLR.W	LED3ON
	MOVE.L	#8,D5		*There are 8 points in a cube (or city)
*	MOVE.L	#24,D5		*There are 24 points in a tank
	JSR	TPROJ
*Projected Terrain Object is now in PTBL, ready to be drawn
*	CLR.W	LED3OFF
	JSR	D_CITY
*	JSR	D_CUBE
*	JSR	D_TANK
	
TERR4	ADDQ.L	#6,T_PTR	*Update Terrain Object Location Pointer

	SUBQ.W	#1,T_CNT	*Update Number of Terrain Objects Remaining
	BNE	TERR1
*All Terrain Objects are now done (whew!)
	RTS
*================================================================================
*Terrain Objects
TERRB:	
*Rotate the Terrain Object
*Select the Terrain Object
	MOVEA.W	#UV2,A0
	LEA.L	CUBE,A4		*Terrain Object is a Cube
	MOVEA.W	#TOBJ,A5	*Output is Terrain Object Point Table
	MOVE.L	#8,D5		* A Cube (or city) has 8 points
	JSR	POST2	
*Rotated Terrain Object is now in TOBJ

*Translate and project the rotated Terrain Object
	LEA.L	TERLOC,A1
	MOVE.L	A1,T_PTR
	MOVE.W	#16,T_CNT	*Do 12 Terrain Objects
TERRB1	
	MOVE.L	T_PTR,A1
	MOVEA.W	#UV2,A0
*--------------------------------------------------------------------
*Is it within the allowable radius?
	MOVE.W	X(A1),D1
	SUB.W	XT(A0),D1
	MULS	D1,D1		D1=(X-XT)**2

	MOVE.W	Y(A1),D0
	SUB.W	YT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2

	MOVE.W	Z(A1),D0
	SUB.W	ZT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		D1=(X-XT)**2 + (Y-YT)**2 + (Z-ZT)**2

* $3000 0000 (unadjusted) seems to be a good allowable radius.
	CMP.L	#$30000000,D1
	BGT	TERRB4			*If it is greater, don't draw it
*--------------------------------------------------------------------
	JSR	PRESUB		*Does one point
* Object center point is at XP,YP,ZP
* Check to see if the object is visible.
	MOVE.W	XP,D0
	CMP.W	#$200,D0
	BLT	TERRB4		
*(XP .GE. $100)
	MOVE.W	YP,D1
	EXT.L	D1
	BPL	TERRB2
	NEG.W	D1
TERRB2	CMP.W	D0,D1
	BGT	TERRB4
*ABS(YP) .LE. XP
	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	TERRB3
	NEG.W	D2
TERRB3	CMP.W	D0,D2
	BGT	TERRB4
*ABS(ZP) .LE XP
*Translate the terrain object to XP,YP,ZP and Project it.
	MOVE.L	#8,D5		*There are 8 points in a cube (or city)
	JSR	TPROJ
*Projected Terrain Object is now in PTBL, ready to be drawn
	JSR	D_CUBE
	
TERRB4	ADDQ.L	#6,T_PTR	*Update Terrain Object Location Pointer

	SUBQ.W	#1,T_CNT	*Update Number of Terrain Objects Remaining
	BNE	TERRB1
*All Terrain Objects are now done (whew!)
	RTS
*-----------------------------------------------------------------------
*Project and draw a dot at (XP,YP,ZP)
*Requires Color Instruction in STAT (ex. $6780)
* Uses D0,D1,D2,A0
PDOT:	MOVE.W 	XP,D0		* D0 = XP 

	CLR.L	D1
	MOVE.W	ZP,D1
	SWAP	D1
	ASR.L	#2,D1
	DIVS	D0,D1		* D1 = ZP/XP	
	ASR.W	#5,D1		* D1 = ZP/XP (scaled)	

	CLR.L	D2
	MOVE.W	YP,D2
	SWAP	D2
	ASR.L	#2,D2
	DIVS	D0,D2		* D2 = YP/XP
	ASR.W	#5,D2		* D2 = YP/XP (scaled)

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A0
	MOVE.W	#$7200,(A0)+
	MOVE.W	STAT,(A0)+	* STAT Instruction
	
	AND.W	#$1FFF,D1	*dy
	MOVE.W	D1,(A0)+
	AND.W	#$1FFF,D2	*dx
	MOVE.W	D2,(A0)+

	MOVE.L	#$000006000,(A0)+	*dot
	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR

	RTS
*-----------------------------------------------------------------------
	PAGE
GSCALE	DC.W	$0FF
	XDEF	GSCALE

* Old, single player only
*GUNS:	BSR	DGUNS		* Display the Guns
*
*	BSR	TRIG		* Generate new tracers if required
*
*	BSR	GHITS		* Check for gun hits
*	
*	RTS

GUNS:	BSR	TRIG		* Trigger Switch Fires a Shot

	BSR	GUNUP		* Update the Gun List

 	LEA	TROUT,A1	* Transform and Draw Ship 1 Shots
	MOVE.W	#$6780,STAT	* Color and Linear Brightness
	JSR	DRDOTS

	BSR	GHITS		* Check for Gun Hits

	RTS

*===============================================================================
TRIG:	TST.B	G_COUNT		*If G_COUNT is non-zero, the tracer timer is
	BEQ 	TRIG1		* operative that prevents another tracer from
	SUBQ.B	#1,G_COUNT	* being fired too soon
	RTS
TRIG1	MOVE.B	INPUTS,D0
	BTST	#5,D0
	BEQ	FIRE
	BTST	#4,D0
	BEQ	FIRE
	RTS

	PAGE
* Fire a Shot
FIRE:	
*	MOVE.B	#$0B,MAINWR+1	* SOUND

	MOVE.B	#$10,G_COUNT	*G_COUNT is decremented each frame if non-zero	
	MOVE.W	#UV2,A0		*Ship 1 fires the guns
	MOVE.W	#G_DATA,A1	*The tracers are in A1

	MOVE.L	#GMAX,D7	*Gun counter

*Check if the tracer is active
FLP1	TST.W	GFLAG(A1)	
	BEQ	FLP2		*ok to use it
	ADD.L	#GBLK,A1	*Update Pointer to next Gun Block 
	SUBQ.L	#1,D7		*out of slots?
	BNE	FLP1		*Try the next one
	RTS			*none available

*Activate the tracer slot
FLP2	MOVE.W	#150,GFLAG(A1)		* Shot Length
	
*for debugging
	MOVE.W 	#$0,GXT(A1)
	MOVE.W 	#$0,GYT(A1)
	MOVE.W 	#$0,GZT(A1)

	MOVE.W 	#$20,GVX(A1)
	MOVE.W 	#$0,GVY(A1)
	MOVE.W 	#$20,GVZ(A1)
	
	NOP		* Patch to RTS to acvtivate test

* Tracer starts from the ship's position
	MOVE.W	XT(A0),GXT(A1)   
	CLR.W	GXT+2(A1)
	MOVE.W	YT(A0),GYT(A1)
	CLR.W	GYT+2(A1)
	MOVE.W	ZT(A0),GZT(A1)
	CLR.W	GZT+2(A1)

* Goes in the direction the ship is pointing, scaled by GSCALE
* added to ship's velocity (80 is a good velocity)

	MOVE.W	AX(A0),D0	* 4000 max
	MULS	GSCALE,D0	* 4000 * FF = 3F C000

	CLR.L	D1
	MOVE.B	VX(A0),D1	* 40 max (normal scaling for velocity is 1/256)
	EXT.W	D1
	SWAP	D1		* 0040.0000 max
	ADD.L	D1,D0		* 007F.0000 max
	MOVE.L	D0,GVX(A1)	*			Gun Velocity X
*---------
	MOVE.W	BX(A0),D0	
	MULS	GSCALE,D0

	CLR.L	D1
	MOVE.B	VY(A0),D1
	EXT.W	D1
	SWAP	D1
	ADD.L	D1,D0
	MOVE.L	D0,GVY(A1)	*			Gun Velocity Y
*---------
	MOVE.W	CX(A0),D0	
	MULS	GSCALE,D0

	CLR.L	D1
	MOVE.B	VZ(A0),D1
	EXT.W	D1
	SWAP	D1
	ADD.L	D1,D0
	MOVE.L	D0,GVZ(A1)	*			Gun Velocity Z

*-------- Everybody wanted a dot in the center, so give 'em a dot
	MOVE.L	VG_PTR,A0
	MOVE.L	#$000006000,(A0)+	*dot
	MOVE.W	#$8040,(A0)+
	MOVE.L	A0,VG_PTR

	RTS

	PAGE
* Check for gun hits
GHITS:	
	MOVE.W	#G_DATA,A1	*The tracers are in A1
	MOVE.L	#GMAX,D7	*Gun counter
	MOVE.W 	#UV4,A0		*Check for Ship 2

GH1		
*Check if the tracer is active
	TST.W	GFLAG(A1)	
	BEQ	GH2		*zero = not active

	MOVE.W	XT(A0),D1
	SUB.W	GXT(A1),D1
	MULS	D1,D1		* D1 = (XT-VXT)**2

	MOVE.W	YT(A0),D0
	SUB.W	GYT(A1),D0
	MULS	D0,D0
	ADD.L	D0,D1		* D1 = (XT-GXT)**2 + (YT-GYT)**2

	MOVE.W	ZT(A0),D0
	SUB.W	GZT(A1),D0
	MULS	D0,D0
	ADD.L	D0,D1		* D1 = (XT-GXT)**2 + (YT-GYT)**2 + (XT-GZT)**2

	CMP.L	#$1000,D1	* The Hit radius
	BGT	GH2
* It's a hit
	MOVE.B	#10,GLOW	* Make it glow for 10 frames
	CLR.W	GFLAG(A1)	* Delete the shot
	ADDQ.B	#1,S2HITS
	CMP.B	#$10,S2HITS
	BLE	GH2		* Not enough hits to make it crash
* Crash Ship 2
	MOVE.B	#$0FF,S2CFLAG	* Ship 2 Crash Flag
	MOVE.B	#255,GLOW

GH2	ADD.L	#GBLK,A1	*Update Pointer to next Gun Block 
	SUBQ.L	#1,D7	
	BNE	GH1

	RTS

	PAGE
* Update the Gun List
GUNUP:	
	MOVE.W	#G_DATA,A1	* The guns are in A1
	
	MOVE.L	#GMAX,D7	* Gun counter

GNLP	TST.W	GFLAG(A1)	* Check if the tracer is active
	BEQ	GNLP3		* 0 = inactive

	SUBQ.W	#1,GFLAG(A1)	* Decrement the Shot Timer
	
	MOVE.L	GVX(A1),D0	* Update Position
	ADD.L	GXT(A1),D0
	MOVE.L	D0,GXT(A1)

	MOVE.L	GVY(A1),D0	
	ADD.L	GYT(A1),D0
	MOVE.L	D0,GYT(A1)

	MOVE.L	GVZ(A1),D0
	ADD.L	GZT(A1),D0
	MOVE.L	D0,GZT(A1)
	BPL	GNLP2		

	CLR.W	GFLAG(A1)	* Delete it, it is below ground
	BRA	GNLP3
	
GNLP2	MOVE.L	GVZ(A1),D0	* Gravity
	SUB.L	#$1000,D0
	MOVE.L	D0,GVZ(A1)

GNLP3	ADD.L	#GBLK,A1	*Update Pointer to next Gun Block 
	SUBQ.L	#1,D7	
	BNE	GNLP		*Go to next tracer

	RTS

	PAGE
*Display the Guns (Original program for single player only)
DGUNS:	
	CLR.B	COUNT

	MOVE.W	#UV2,A0		*Ship 1 (working copy) looks at the guns
	MOVE.W	#G_DATA,A1	*The guns are in A1
	MOVE.W	#PTBL,A2	*A list will be generated for Presub
	
	MOVE.L	#GMAX,D7	*Gun counter


GUNLP	TST.W	GFLAG(A1)	*Check if the tracer is active
	BEQ	GUNLP4		* 0 = inactive
	
	MOVE.L	GVX(A1),D0	*Update Position
	ADD.L	GXT(A1),D0
	MOVE.L	D0,GXT(A1)

	MOVE.L	GVY(A1),D1	
	ADD.L	GYT(A1),D1
	MOVE.L	D1,GYT(A1)

	MOVE.L	GVZ(A1),D2
	ADD.L	GZT(A1),D2
	MOVE.L	D2,GZT(A1)
	BPL	GUNLP2		

	CLR.W	GFLAG(A1)	*Delete it, it is below ground
	BRA	GUNLP4

GUNLP2	MOVE.L	GVZ(A1),D2	*(Gravity)
	SUB.L	#$1000,D2
	MOVE.L	D2,GVZ(A1)

*Is it within the allowable radius?
	MOVE.W	GXT(A1),D1
	SUB.W	XT(A0),D1
	MULS	D1,D1
	
	MOVE.W	GYT(A1),D0
	SUB.W	YT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1

	MOVE.W	GZT(A1),D0
	SUB.W	ZT(A0),D0
	MULS	D0,D0
	ADD.L	D0,D1		*D1 = (X-XT)**2 + (Y-YT)**2 + (Z-ZT)**2	

* $1000 0000 (unadjusted) seems to be a good allowable radius.
	CMP.L	#$10000000,D1
	BLT	GUNLP3		*If it is too far, delete it and don't draw it
	CLR.W	GFLAG(A1)
	BRA	GUNLP4		

*Add it to the Point Table
GUNLP3	MOVE.W	GXT(A1),(A2)+
	MOVE.W	GYT(A1),(A2)+
	MOVE.W	GZT(A1),(A2)+
	ADDQ.B	#1,COUNT

GUNLP4	ADD.L	#GBLK,A1	*Update Pointer to next Gun Block 
	SUBQ.L	#1,D7	
	BNE	GUNLP		*Go to next tracer

* If there aren't any active, don't draw any	
	TST	COUNT
	BNE	GLT2
	RTS
*Points are in Point Table

GLT2	MOVE.L	VG_PTR,A3
	MOVE.W	#$7200,(A3)+
	MOVE.W	#$6780,(A3)+	* STAT Instruction
	MOVE.L	A3,VG_PTR
	
	CLR.W	CURRX
	CLR.W	CURRY

	MOVEA.W	#UV2,A0
	MOVEA.W	#PTBL,A1	* 

GLT3	JSR	PRESUB		* Output in XP, YP, ZP 

* Light is at XP,YP,ZP
* Check to see if it is visible.
	MOVE.W	XP,D0
	CMP.W	#$80,D0
	BLE	GLT9		* Bail out if XP is negative

GLT4	MOVE.W	YP,D1
	EXT.L	D1
	BPL	GLT5
	NEG.W	D1
GLT5	CMP.W	D0,D1
	BGT	GLT9		* Bail out if ABS(YP) > XP

* ABS(YP) .LE. XP
GLT6	MOVE.W	ZP,D2
	EXT.L	D2
	BPL	GLT7
	NEG.W	D2
GLT7	CMP.W	D0,D2
	BGT	GLT9			

* ABS(ZP) .LE XP

GLT8	

* Project the Light at (XP,YP,ZP) and draw a dot
	MOVE.W 	XP,D0		* D0 = XP 

*Screen Y
	CLR.L	D1
	MOVE.W	ZP,D1
	SWAP	D1
	ASR.L	#2,D1
	DIVS	D0,D1		* D1 = ZP/XP	
	ASR.W	#5,D1		* D1 = ZP/XP (scaled)	

	MOVE.W	D1,D3
	SUB.W	CURRY,D1	* D1 = delta Y
	MOVE.W	D3,CURRY	* Update Current Y

*Screen X
	CLR.L	D2
	MOVE.W	YP,D2
	SWAP	D2
	ASR.L	#2,D2
	DIVS	D0,D2		* D2 = YP/XP
	ASR.W	#5,D2		* D2 = YP/XP (scaled)

	MOVE.W	D2,D3
	SUB.W	CURRX,D2	* D2 = delta X
	MOVE.W	D3,CURRX	* Update Current X

* Format and add to VG Buffer
	MOVE.L	VG_PTR,A3
	
	AND.W	#$1FFF,D1	*dy
	MOVE.W	D1,(A3)+
	AND.W	#$1FFF,D2	*dx
	MOVE.W	D2,(A3)+

	MOVE.L	#$000006000,(A3)+	*dot
	MOVE.L	A3,VG_PTR

* Check if last entry in PTBL
GLT9	ADDQ.L	#6,A1
	SUBQ.B	#1,COUNT
	BNE	GLT3

	MOVE.L	VG_PTR,A3
	MOVE.W	#$8040,(A3)+
	MOVE.L	A3,VG_PTR

	RTS

	END

	
