	TTL 'OLD DRAWING ROUTINES '

* For Reference Only

	INCLUDE 'EQUATES.ASM'
	INCLUDE	'XREFS.ASM'

	XDEF	DRAW,PLOT,CENTER,VGHALT,STAT,DEND
	XDEF	D_SQ,D_TANK,D_CUBE,D_ROC,D_AIR,D_SAU,D_HIND,D_HROT
	XDEF	FASTCUBE,FAST,SLOW

* SUBTITLE 'VECTOR SUBROUTINES'
* A0 = VG ADDRESS POINTER 
* A1 = ADDR(PTBL)
* A2 = POINT NUMBER * 4
* 
* D0 = CURRENT Y POSITION
* D1 = CURRENT X POSITION
* D2 = TEMP VG DATA
* D3 = TEMP VG DATA
*
*	D0 and D1 are zeroed by CENTER commands.
*	Calling program initializes A1 and A0 at the beginning of a sequence of
*		commands.
*	Calling program supplies A2 for commands PLOT and DRAW. 
*	[Clear A2 at beginning of object.]
*	Calling Program simply calls CENTER and HALT for these commands.  
*
DRAW	
	MOVE.W	Y(A2,A1),D3	* NEW Y POSITION (ea = Addr(PTBL) + #PT*4)
	MOVE.W	D3,D2		* MAKE A COPY
	SUB.W	D0,D3		* D3 = DELTA Y = NEW - CURRENT
	AND.W	#$1FFF,D3	* VECTOR INSTRUCTION		
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
	MOVE.W	D2,D0		* UPDATE CURRENT Y POSITION
*				  (That's why we made a copy)
	MOVE.W	X(A2,A1),D3	* NEW X POSITION
	MOVE.W	D3,D2		* MAKE A COPY
	SUB.W	D1,D3		* D3 = DELTA X = NEW - CURRENT
	OR.W	#$E000,D3	* BRITE = ON
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
	MOVE.W	D2,D1		* UPDATE CURRENT X POSITION
*				  (That's why we made a copy)
	RTS

*A Plot is a DRAWTO with Beam Off.
PLOT	
	MOVE.W	Y(A2,A1),D3	* NEW Y POSITION (ea = Addr(PTBL) + #PT*4)
	MOVE.W	D3,D2		* MAKE A COPY
	SUB.W	D0,D3		* D3 = DELTA Y = NEW - CURRENT
	AND.W	#$1FFF,D3	* VECTOR INSTRUCTION		
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
	MOVE.W	D2,D0		* UPDATE CURRENT Y POSITION
*				  (That's why we made a copy)
	MOVE.W	X(A2,A1),D3	* NEW X POSITION
	MOVE.W	D3,D2		* MAKE A COPY
	SUB.W	D1,D3		* D3 = DELTA X = NEW - CURRENT
	AND.W	#$1FFF,D3	* BRITE = OFF
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
	MOVE.W	D2,D1		* UPDATE CURRENT X POSITION
*				  (That's why we made a copy)
	RTS

CENTER	
	MOVE.W	#$8040,(A0)+	* CENTER COMMAND and increment pointer
	CLR.L	D1		* Y POSITION = 0
	CLR.L	D0		* X POSITION = 0
	RTS	
*
VGHALT
	MOVE.W	#$2000,(A0)+	* VGHALT and increment pointer
	RTS	
*
STAT	MOVE.B	COLOR,D2
	AND.B	#$07,D2		*COLOR IS LOW THREE BITS
	OR.B	#$60,D2		*COLOR STAT INSTRUCTION
	LSL.W	#8,D2
	OR.B	ZSTAT,D2
	MOVE.W	D2,(A0)+	* WRITE TO VG BUFFER and increment pointer

	RTS	
	PAGE
* Draw the Square
D_SQ
	MOVEA	VG_PTR,A0
	MOVEA	#PTBL,A1

	MOVE.W 	#$7180,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W	#$6480,(A0)+	*COLOR RED, STAT 80

	BSR 	CENTER	

	MOVE.W	#0*4,A2
	BSR	PLOT

	MOVE.W	#1*4,A2
	BSR	DRAW

	MOVE.W	#2*4,A2
	BSR	DRAW

	MOVE.W	#3*4,A2
	BSR 	DRAW

	MOVE.W	#0*4,A2
	BSR	DRAW

	BSR	CENTER

	MOVE.L	A0,VG_PTR

	RTS		

	PAGE
* Draw the Tank
*TANK
*PLOT   23, DRAWTO 22				.B 17,16
*PLOT   12, DRAWTO 13				.B 0C,0D
*PLOT   14, DRAWTO 20,18,15,14,17,16,19,21,17	.B 0E,14,12,0F,0E,11,10,13,15,11
*PLOT   15, DRAWTO 16				.B 0F,10
*PLOT   19, DRAWTO 18				.B 13,12
*PLOT   20, DRAWTO 21				.B 14,15
*PLOT    3, DRAWTO 00,04,07,06,02,03,07		.B 3,0,4,7,6,2,3,7,
*DRAWTO 11,10,06,05,09,10,13			.L 0B,0A,6,5,9,0A,0D
*DRAWTO 09,08,11,12,8,4,5,1,2		 	.L 9,8,0B,0C,8,4,5,1,2
*PLOT    1, DRAWTO 0				.B 1,0


* DRAW A TANK  	A0 = VG ADDRESS POINTER
*	       	A1 = ADDRESS OF POINT TABLE
*		A2 = NUMBER OF THE POINT * 4 

D_TANK	MOVEA	VG_PTR,A0
	MOVEA	#PTBL,A1

	MOVE.W 	#$7280,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W 	#$6780,(A0)+	*COLOR WHT, ZSTAT=80

	BSR	CENTER

	MOVE.W	#23*4,A2	*PLOT 23
	BSR	PLOT

	MOVE.W	#22*4,A2	*DRAWTO 22
	BSR 	DRAW

	MOVE.W	#12,A2		*PLOT 12
	BSR	PLOT

	MOVE.W	#13*4,A2	*DRAWTO 13
	BSR	DRAW

	MOVE.W	#14*4,A2	*PLOT 14
	BSR	PLOT

	MOVE.W	#20*4,A2	*DRAWTO 20
	BSR 	DRAW

	MOVE.W	#18*4,A2	*DRAWTO 18
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWTO 15
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWTO 14
	BSR	DRAW

	MOVE.W	#17*4,A2	*DRAWTO 17
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR 	DRAW					

	MOVE.W	#19*4,A2	*DRAWTO 19
	BSR	DRAW

	MOVE.W	#21*4,A2	*DRAWTO 21
	BSR	DRAW

	MOVE.W	#17*4,A2	*DRAWTO 17
	BSR	DRAW

	MOVE.W	#15*4,A2	*PLOT 15
	BSR 	PLOT

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR 	PLOT

	MOVE.W	#19*4,A2	*PLOT 19
	BSR	PLOT

	MOVE.W	#18*4,A2	*DRAWTO 18
	BSR 	DRAW	

	MOVE.W	#20*4,A2	*PLOT 20
	BSR	PLOT

	MOVE.W	#21*4,A2	*DRAWTO 21
	BSR	DRAW

	MOVE.W	#3*4,A2		*PLOT 3
	BSR	PLOT

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR 	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWTO 2
	BSR	DRAW

	MOVE.W	#3*4,A2		*DRAWTO 3
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWTO 11
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWTO 10
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWTO 10
	BSR	DRAW

	MOVE.W	#13*4,A2	*DRAWTO 13
	BSR 	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR 	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWTO 11
	BSR	DRAW

	MOVE.W	#12*4,A2	*DRAWTO 12
	BSR 	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWTO 1
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWTO 1
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWTO 2
	BSR	DRAW

	BSR 	CENTER		*CENTER

	MOVE.L	A0,VG_PTR

	RTS	

	PAGE
* Draw the Cube
*CUBE
*PLOT 0, DRAWTO 1,2,3,0,4			.B 0,1,2,3,0,4
*DRAWTO  5,1,5,6,2,6				.L 5,1,5,6,2,6
*DRAWTO	 7,3,7,4				.L 7,3,7,4
*
* DRAW A CUBE 	A0 = VG ADDRESS POINTER
*	       	A1 = ADDRESS OF POINT TABLE
*		A2 = NUMBER OF THE POINT * 4 

D_CUBE	MOVEA	VG_PTR,A0
	MOVEA	#PTBL,A1

	MOVE.W 	#$7180,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W 	#$6780,(A0)+	*COLOR WHT, ZSTAT=80

	BSR	CENTER

	MOVE.W	#0*4,A2		*PLOT 0
	BSR	PLOT

	MOVE.W	#1*4,A2		*DRAWTO 1
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWTO 2
	BSR	DRAW

	MOVE.W	#3*4,A2		*DRAWTO 3
	BSR	DRAW		

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWTO 1
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWTO 2
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#3*4,A2		*DRAWTO 3
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4
	BSR	DRAW

	BSR	CENTER		*CENTER

	MOVE.L	A0,VG_PTR	

SLOW	RTS 	

	PAGE
* Draw the Rocket Ship
*ROCKET SHIP
*PLOT 5, DRAWTO 0,6,7,0,8,10,0,9,5		.B 5,0,6,7,0,8,A,0,9,5
*PLOT 1, DRAWTO 2,3,4				.B 1,2,3,4
*PLOT 8, DRAWTO 7,23,20,8			.B 8,7,17,14,8
*DRAWTO 12,18,20,24,18				.L C,12,14,18,12
*PLOT 12, DRAWTO 10				.B C,A
*PLOT 5, DRAWTO 6,21,19,5			.B 5,6,15,13,5
*DRAWTO 11,17,19,22,17				.L B,11,13,16,11
*PLOT 11, DRAWTO 9,22,21,16,13,14,15		.B B,9,16,15,10,D,E,F
*DRAWTO 16,23,24,22				.L 10,17,18,16
*PLOT	24, DRAWTO 10,9				.B 18,A,9
*
*
* DRAW A ROCKET	SHIP	A0 = VG ADDRESS POINTER
*	       		A1 = ADDRESS OF POINT TABLE
*			A2 = NUMBER OF THE POINT * 4 

D_ROC	MOVEA	VG_PTR,A0	
	MOVEA	#PTBL,A1

	MOVE.W 	#$7180,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W 	#$6780,(A0)+	*COLOR WHT, ZSTAT=80

	MOVE.W	#5*4,A2		*PLOT 5
	BSR	PLOT

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR	DRAW
	
	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWTO 10
	BSR	DRAW

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5		
	BSR	DRAW

	MOVE.W	#1*4,A2		*PLOT 1 
	BSR	PLOT

	MOVE.W	#2*4,A2		*DRAWTO 2
	BSR	DRAW

	MOVE.W	#3*4,A2		*DRAWTO 3
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4				
	BSR	DRAW

	MOVE.W	#8*4,A2		*PLOT 8 
	BSR	PLOT

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#23*4,A2	*DRAWTO 23
	BSR	DRAW

	MOVE.W	#20*4,A2	*DRAWTO 20
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8			
	BSR	DRAW

	MOVE.W	#12*4,A2	*DRAWTO 12
	BSR	DRAW

	MOVE.W	#18*4,A2	*DRAWTO 18
	BSR	DRAW

	MOVE.W	#20*4,A2	*DRAWTO 20
	BSR	DRAW

	MOVE.W	#24*4,A2	*DRAWTO 24
	BSR	DRAW

	MOVE.W	#18*4,A2	*DRAWTO 18				
	BSR	DRAW

	MOVE.W	#12*4,A2	*PLOT 12 
	BSR	PLOT

	MOVE.W	#10*4,A2	*DRAWTO 10				
	BSR	DRAW

	MOVE.W	#5*4,A2		*PLOT 5
	BSR	PLOT

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#21*4,A2	*DRAWTO 21
	BSR	DRAW

	MOVE.W	#19*4,A2	*DRAWTO 19
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5			
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWTO 11
	BSR	DRAW

	MOVE.W	#17*4,A2	*DRAWTO 17
	BSR	DRAW

	MOVE.W	#19*4,A2	*DRAWTO 19
	BSR	DRAW

	MOVE.W	#22*4,A2	*DRAWTO 22
	BSR	DRAW

	MOVE.W	#17*4,A2	*DRAWTO 17				
	BSR	DRAW

	MOVE.W	#11*4,A2	*PLOT 11 
	BSR	PLOT

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR	DRAW

	MOVE.W	#22*4,A2	*DRAWTO 22
	BSR	DRAW

	MOVE.W	#21*4,A2	*DRAWTO 21
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR	DRAW

	MOVE.W	#13*4,A2	*DRAWTO 13
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWTO 14
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWTO 15		
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR	DRAW

	MOVE.W	#23*4,A2	*DRAWTO 23
	BSR	DRAW

	MOVE.W	#24*4,A2	*DRAWTO 24
	BSR	DRAW

	MOVE.W	#22*4,A2	*DRAWTO 22				
	BSR	DRAW

	MOVE.W	#24*4,A2	*PLOT	24 
	BSR	PLOT

	MOVE.W	#10*4,A2	*DRAWTO 10
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9				
	BSR	DRAW

	BSR 	CENTER		*CENTER

	MOVE.L	A0,VG_PTR	

	RTS	

	PAGE
* Draw the Airplane
*STUBBY
*PLOT 5, DRAWTO 1,0,4,8				.B 5,1,0,4,8
*DRAWTO 0,2,3,1,6,5				.L 0,2,3,1,6,5
*PLOT 13, DRAWTO 12,11,10			.B D,C,B,A
*PLOT 4, DRAWTO 21,22,23,4,9,2			.B 4,15,16,17,4,9,2
*PLOT 3, DRAWTO 7,5,16,15,14,5			.B 3,7,5,10,F,E,5
*PLOT 19, DRAWTO 6,8,17,19,14,23,17		.B 13,6,8,11,13,E,17,11
*PLOT 23, DRAWTO 18,22				.B 17,12,16
*PLOT 21, DRAWTO 9,18,20,15			.B 15,9,12,14,F
*PLOT 16, DRAWTO 7,9				.B 10,7,9
*PLOT 7, DRAWTO 20,14				.B 7,14,E
* DRAW STUBBY 	A0 = VG ADDRESS POINTER
*	       	A1 = ADDRESS OF POINT TABLE
*		A2 = NUMBER OF THE POINT * 4 

D_AIR	MOVEA	VG_PTR,A0
	MOVEA	#PTBL,A1

	MOVE.W 	#$7180,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W 	#$6780,(A0)+	*COLOR WHT, ZSTAT=80

	MOVE.W	#5*4,A2		*PLOT 5 
	BSR	PLOT

	MOVE.W	#1*4,A2		*DRAWTO 1
	BSR	DRAW

	MOVE.W	#0*4,A2		*DRAWT0 0
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWT0 4
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWT0 8			
	BSR	DRAW

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWT0 2
	BSR	DRAW

	MOVE.W	#3*4,A2		*DRAWT0 3
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWT0 1
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWT0 6
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWT0 5				
	BSR	DRAW

	MOVE.W	#13*4,A2	*PLOT 13 
	BSR	PLOT

	MOVE.W	#12*4,A2	*DRAWTO 12
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWT0 11
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWT0 10			
	BSR	DRAW

	MOVE.W	#4*4,A2		*PLOT 4 
	BSR	PLOT

	MOVE.W	#21*4,A2	*DRAWTO 21
	BSR	DRAW

	MOVE.W	#22*4,A2	*DRAWT0 22
	BSR	DRAW

	MOVE.W	#23*4,A2	*DRAWT0 23
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWT0 4
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWT0 9
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWT0 2			
	BSR	DRAW

	MOVE.W	#3*4,A2		*PLOT 3 
	BSR	PLOT

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWT0 5
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWT0 16
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWT0 15
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWT0 14
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWT0 5			
	BSR	DRAW

	MOVE.W	#19*4,A2	*PLOT 19 
	BSR	PLOT

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWT0 8
	BSR	DRAW

	MOVE.W	#17*4,A2	*DRAWT0 17
	BSR	DRAW

	MOVE.W	#19*4,A2	*DRAWT0 19
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWT0 14
	BSR	DRAW

	MOVE.W	#23*4,A2	*DRAWT0 23
	BSR	DRAW

	MOVE.W	#17*4,A2	*DRAWT0 17		
	BSR	DRAW

	MOVE.W	#23*4,A2	*PLOT 23 
	BSR	PLOT

	MOVE.W	#18*4,A2	*DRAWTO 18
	BSR	DRAW

	MOVE.W	#22*4,A2	*DRAWT0 22				
	BSR	DRAW

	MOVE.W	#21*4,A2	*PLOT 21 
	BSR	PLOT

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR	DRAW

	MOVE.W	#18*4,A2	*DRAWT0 18
	BSR	DRAW

	MOVE.W	#20*4,A2	*DRAWT0 20
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWT0 15			
	BSR	DRAW

	MOVE.W	#16*4,A2	*PLOT 16 
	BSR	PLOT

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWT0 9				
	BSR	DRAW

	MOVE.W	#7*4,A2		*PLOT 7 
	BSR	PLOT

	MOVE.W	#20*4,A2	*DRAWTO 20
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWT0 14				
	BSR	DRAW

	BSR	CENTER		*CENTER

	MOVE.L	A0,VG_PTR	

	RTS	
	
	PAGE
* Draw the Flying Saucer
 
*SAUCER
*PLOT 16, DRAWTO 8,9,16,10,11,16,12,13		.B 10,8,9,10,A,B,10,C,D
*DRAWTO 16,14,15,16				.L 10,E,F,10
*PLOT 0, DRAWTO 7,15,8,0,1,9,10,2,3		.B 0,7,F,8,0,1,9,A,2,3
*DRAWTO 11,12,4,5,13,14,6,7			.L B,C,4,5,D,E,6,7
*PLOT 6, DRAWTO 5				.B 6,5
*PLOT 4, DRAWTO 3				.B 4,3
*PLOT 2, DRAWTO 1				.B 2,1
* DRAW THE SAUCER 	A0 = VG ADDRESS POINTER
*	       		A1 = ADDRESS OF POINT TABLE
*			A2 = NUMBER OF THE POINT * 4 

D_SAU	MOVEA	VG_PTR,A0	
	MOVEA	#PTBL,A1

	MOVE.W 	#$7180,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W 	#$6780,(A0)+	*COLOR WHT, ZSTAT=80

	MOVE.W	#16*4,A2	*PLOT 16 
	BSR	PLOT

	MOVE.W	#8*4,A2		*DRAWTO 8
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWTO 10
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWTO 11
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR	DRAW

	MOVE.W	#12*4,A2	*DRAWTO 12
	BSR	DRAW

	MOVE.W	#13*4,A2	*DRAWTO 13		
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWTO 14
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWTO 15
	BSR	DRAW

	MOVE.W	#16*4,A2	*DRAWTO 16				
	BSR	DRAW

	MOVE.W	#0*4,A2		*PLOT 0 
	BSR	PLOT

	MOVE.W	#7*4,A2		*DRAWTO 7
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWTO 15
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8
	BSR	DRAW

	MOVE.W	#0*4,A2		*DRAWTO 0
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWTO 1
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWTO 10
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWTO 2
	BSR	DRAW

	MOVE.W	#3*4,A2		*DRAWTO 3		
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWTO 11
	BSR	DRAW

	MOVE.W	#12*4,A2	*DRAWTO 12
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4
	BSR	DRAW

	MOVE.W	#5*4,A2		*DRAWTO 5
	BSR	DRAW

	MOVE.W	#13*4,A2	*DRAWTO 13
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWTO 14
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWTO 6
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7			
	BSR	DRAW

	MOVE.W	#6*4,A2		*PLOT 6 
	BSR	PLOT

	MOVE.W	#5*4,A2		*DRAWTO 5				
	BSR	DRAW

	MOVE.W	#4*4,A2		*PLOT 4 
	BSR	PLOT

	MOVE.W	#3*4,A2		*DRAWTO 3				
	BSR	DRAW

	MOVE.W	#2*4,A2		*PLOT 2 
	BSR	PLOT

	MOVE.W	#1*4,A2		*DRAWTO 1				
	BSR	DRAW

	BSR	CENTER		*CENTER

	MOVE.L	A0,VG_PTR	

	RTS	
		
	PAGE
* Draw the Buzz Bomber
*BUZZ BOMB
*PLOT 13, DRAWTO 12,6,0,1,7,8,9		 	.B D,C,6,0,1,7,8,9
*DRAWTO 10,11,6,7,12,8,2,3			.L A,B,6,7,C,8,2,3
*DRAWTO 9,12,10,4,5,11,12			.L 9,C,A,4,5,B,C
*PLOT 24, DRAWTO 23,22,24,25,23			.B 18,17,16,18,19,17
*PLOT 25, DRAWTO 22				.B 19,16
*PLOT 1, DRAWTO 2				.B 1,2
*PLOT 3, DRAWTO 4				.B 3,4
*PLOT 5, DRAWTO 0				.B 5,0
*PLOT 18, DRAWTO 19,20,21,18,14,15,16,17,15	.B 12,13,14,15,12,E,F,10,11,E
*PLOT 15, DRAWTO 19				.B F,13
*PLOT 20, DRAWTO 16				.B 14,10
*PLOT 17, DRAWTO 21				.B 11,15
D_BUZZ



	PAGE
* Draw the Flying M
*FLYING M
*PLOT 0, DRAWTO 1,9			.B 0,0,0,1,9	
*					*UNDERLINE NOT DRAWN - PATCHABLE
*PLOT 1, DRAWT 2,10			.B 1,2,A
*PLOT 2, DRAWTO 3,11			.B 2,3,B
*PLOT 3, DRAWTO 4,12			.B 3,4,C
*PLOT 4, DRAWTO 5			.B 4,5,D
*PLOT 5, DRAWTO 6,14			.B 5,6,E
*PLOT 6, DRAWTO 7			.B 6,7			
*					*PATCH - UNDERLINE NOT DRAWN
*PLOT 15, DRAWTO 8,9,10,11,12,13,14,15	.B F,8,9,A,B,C,D,E,F
*PLOT 7, DRAWTO 0			.B 7,0

	PAGE
* Draw the Hind (Russian Helicopter)
*HIND BODY
*PLOT 3, DRAWTO 5, 1, 0, 4, 2			.B 3,5,1,0,4,2
*DRAWTO 8, 9, 7, 6, 8				.L 8,9,7,6,8
*PLOT 9, DRAWTO 3				.B 9,3
*PLOT 5, DRAWTO 7, 1				.B 5,7,1
*PLOT 0, DRAWTO 6, 4				.B 0,6,4
*PLOT 6, DRAWTO 10, 11, 7			.B 6,A,B,7
*PLOT 9, DRAWTO 21, 20, 8			.B 9,15,14,8
*PLOT 13, DRAWTO 12, 18, 19			.B D,C,12,13
*PLOT 17, DRAWTO 16, 15, 14			.B 11,10,F,E
*PLOT 11, DRAWTO 23, 25, 21, 20, 24		.B B,17,19,15,14,18
*DRAWTO 22, 10					.L 16,A
*PLOT 20, DRAWTO 21				.B 14,15
*PLOT 23, DRAWTO 22				.B 17,16
*PLOT 24, DRAWTO 25				.B 18,19
*PLOT 26, DRAWTO 28, 34, 42, 40, 38, 36		.B 1A,1C,22,2A,28,26,24
*DRAWTO 30, 32, 26, 27, 29, 35, 43		.L 1E,20,1A,1B,1D,23,2B
*DRAWTO 41, 39, 37, 31, 33, 27			.L 29,27,25,1F,21,1B
*PLOT 29, DRAWTO 28				.B 1D,1C
*PLOT 34, DRAWTO 35				.B 22,23
*PLOT 31, DRAWTO 30				.B 1F,1E
*PLOT 36, DRAWTO 37				.B 24,25
*PLOT 39, DRAWTO 38				.B 27,26
*PLOT 40, DRAWTO 32, 33, 41			.B 28,20,21,29
*PLOT 53, DRAWTO 48, 49, 50, 51, 53		.B 35,30,31,32,33,35
*PLOT 52, DRAWTO 44, 45, 46, 47			.B 34,2C,2D,2E,2F
*PLOT 42, DRAWTO 43				.B 2A,2B
*PLOT 33, DRAWTO 35				.B 21,23
*PLOT 34, DRAWTO 32				.B 22,20
*
*
*
*Draw HIND body
D_HIND	MOVEA	VG_PTR,A0	
	MOVEA	#PTBL,A1

	MOVE.W	#3*4,A2		*PLOT 3 
	BSR	PLOT

	MOVE.W	#5*4,A2		*DRAWTO 5 
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWTO 1 
	BSR	DRAW

	MOVE.W	#0*4,A2		*DRAWTO 0 
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4 
	BSR	DRAW

	MOVE.W	#2*4,A2		*DRAWTO 2			
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8 
	BSR	DRAW

	MOVE.W	#9*4,A2		*DRAWTO 9 
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7 
	BSR	DRAW

	MOVE.W	#6*4,A2		*DRAWTO 6 
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8				
	BSR	DRAW

	MOVE.W	#9*4,A2		*PLOT 9 
	BSR	PLOT

	MOVE.W	#3*4,A2		*DRAWTO 3				
	BSR	DRAW

	MOVE.W	#5*4,A2		*PLOT 5 
	BSR	PLOT

	MOVE.W	#7*4,A2		*DRAWTO 7 
	BSR	DRAW

	MOVE.W	#1*4,A2		*DRAWTO 1				
	BSR	DRAW

	MOVE.W	#0*4,A2		*PLOT 0 
	BSR	PLOT

	MOVE.W	#6*4,A2		*DRAWTO 6 
	BSR	DRAW

	MOVE.W	#4*4,A2		*DRAWTO 4				
	BSR	DRAW

	MOVE.W	#6*4,A2		*PLOT 6 
	BSR	PLOT

	MOVE.W	#10*4,A2	*DRAWTO 10 
	BSR	DRAW

	MOVE.W	#11*4,A2	*DRAWTO 11 
	BSR	DRAW

	MOVE.W	#7*4,A2		*DRAWTO 7			
	BSR	DRAW

	MOVE.W	#9*4,A2		*PLOT 9 
	BSR	PLOT

	MOVE.W	#21*4,A2	*DRAWTO 21 
	BSR	DRAW

	MOVE.W	#20*4,A2	*DRAWTO 20 
	BSR	DRAW

	MOVE.W	#8*4,A2		*DRAWTO 8			
	BSR	DRAW

	MOVE.W	#13*4,A2	*PLOT 13 
	BSR	PLOT

	MOVE.W	#12*4,A2	*DRAWTO 12 
	BSR	DRAW

	MOVE.W	#18*4,A2	*DRAWTO 18 
	BSR	DRAW

	MOVE.W	#19*4,A2	*DRAWTO 19			
	BSR	DRAW

	MOVE.W	#17*4,A2	*PLOT 17 
	BSR	PLOT

	MOVE.W	#16*4,A2	*DRAWTO 16 
	BSR	DRAW

	MOVE.W	#15*4,A2	*DRAWTO 15 
	BSR	DRAW

	MOVE.W	#14*4,A2	*DRAWTO 14			
	BSR	DRAW

	MOVE.W	#11*4,A2	*PLOT 11 
	BSR	PLOT

	MOVE.W	#23*4,A2	*DRAWTO 23 
	BSR	DRAW

	MOVE.W	#25*4,A2	*DRAWTO 25 
	BSR	DRAW

	MOVE.W	#21*4,A2	*DRAWTO 21 
	BSR	DRAW

	MOVE.W	#20*4,A2	*DRAWTO 20 
	BSR	DRAW

	MOVE.W	#24*4,A2	*DRAWTO 24		
	BSR	DRAW

	MOVE.W	#22*4,A2	*DRAWTO 22 
	BSR	DRAW

	MOVE.W	#10*4,A2	*DRAWTO 10				
	BSR	DRAW

	MOVE.W	#20*4,A2	*PLOT 20 
	BSR	PLOT

	MOVE.W	#21*4,A2	*DRAWTO 21				
	BSR	DRAW

	MOVE.W	#23*4,A2	*PLOT 23 
	BSR	PLOT

	MOVE.W	#22*4,A2	*DRAWTO 22				
	BSR	DRAW

	MOVE.W	#24*4,A2	*PLOT 24 
	BSR	PLOT

	MOVE.W	#25*4,A2	*DRAWTO 25				
	BSR	DRAW

	MOVE.W	#26*4,A2	*PLOT 26 
	BSR	PLOT

	MOVE.W	#28*4,A2	*DRAWTO 28 
	BSR	DRAW

	MOVE.W	#34*4,A2	*DRAWTO 34 
	BSR	DRAW

	MOVE.W	#42*4,A2	*DRAWTO 42 
	BSR	DRAW

	MOVE.W	#40*4,A2	*DRAWTO 40 
	BSR	DRAW

	MOVE.W	#38*4,A2	*DRAWTO 38 
	BSR	DRAW

	MOVE.W	#36*4,A2	*DRAWTO 36		
	BSR	DRAW

	MOVE.W	#30*4,A2	*DRAWTO 30 
	BSR	DRAW

	MOVE.W	#32*4,A2	*DRAWTO 32 
	BSR	DRAW

	MOVE.W	#26*4,A2	*DRAWTO 26 
	BSR	DRAW

	MOVE.W	#27*4,A2	*DRAWTO 27
	BSR	DRAW

	MOVE.W	#29*4,A2	*DRAWTO 29 
	BSR	DRAW

	MOVE.W	#35*4,A2	*DRAWTO 35 
	BSR	DRAW

	MOVE.W	#43*4,A2	*DRAWTO 43		
	BSR	DRAW

	MOVE.W	#41*4,A2	*DRAWTO 41 
	BSR	DRAW

	MOVE.W	#39*4,A2	*DRAWTO 39 
	BSR	DRAW

	MOVE.W	#37*4,A2	*DRAWTO 37 
	BSR	DRAW

	MOVE.W	#31*4,A2	*DRAWTO 31 
	BSR	DRAW

	MOVE.W	#33*4,A2	*DRAWTO 33 
	BSR	DRAW

	MOVE.W	#27*4,A2	*DRAWTO 27			
	BSR	DRAW

	MOVE.W	#29*4,A2	*PLOT 29 
	BSR	PLOT

	MOVE.W	#28*4,A2	*DRAWTO 28				
	BSR	DRAW

	MOVE.W	#34*4,A2	*PLOT 34 
	BSR	PLOT

	MOVE.W	#35*4,A2	*DRAWTO 35				
	BSR	DRAW

	MOVE.W	#31*4,A2	*PLOT 31 
	BSR	PLOT

	MOVE.W	#30*4,A2	*DRAWTO 30				
	BSR	DRAW

	MOVE.W	#36*4,A2	*PLOT 36 
	BSR	PLOT

	MOVE.W	#37*4,A2	*DRAWTO 37				
	BSR	DRAW

	MOVE.W	#39*4,A2	*PLOT 39 
	BSR	PLOT

	MOVE.W	#38*4,A2	*DRAWTO 38				
	BSR	DRAW

	MOVE.W	#40*4,A2	*PLOT 40 
	BSR	PLOT

	MOVE.W	#32*4,A2	*DRAWTO 32 
	BSR	DRAW

	MOVE.W	#33*4,A2	*DRAWTO 33 
	BSR	DRAW

	MOVE.W	#41*4,A2	*DRAWTO 41			
	BSR	DRAW

	MOVE.W	#53*4,A2	*PLOT 53 
	BSR	PLOT

	MOVE.W	#48*4,A2	*DRAWTO 48 
	BSR	DRAW

	MOVE.W	#49*4,A2	*DRAWTO 49 
	BSR	DRAW

	MOVE.W	#50*4,A2	*DRAWTO 50 
	BSR	DRAW

	MOVE.W	#51*4,A2	*DRAWTO 51 
	BSR	DRAW

	MOVE.W	#53*4,A2	*DRAWTO 53		
	BSR	DRAW

	MOVE.W	#52*4,A2	*PLOT 52 
	BSR	PLOT

	MOVE.W	#44*4,A2	*DRAWTO 44 
	BSR	DRAW

	MOVE.W	#45*4,A2	*DRAWTO 45 
	BSR	DRAW

	MOVE.W	#46*4,A2	*DRAWTO 46 
	BSR	DRAW

	MOVE.W	#47*4,A2	*DRAWTO 47			
	BSR	DRAW

	MOVE.W	#42*4,A2	*PLOT 42 
	BSR	PLOT

	MOVE.W	#43*4,A2	*DRAWTO 43				
	BSR	DRAW

	MOVE.W	#33*4,A2	*PLOT 33 
	BSR	PLOT

	MOVE.W	#35*4,A2	*DRAWTO 35				
	BSR	DRAW

	MOVE.W	#34*4,A2	*PLOT 34 
	BSR	PLOT

	MOVE.W	#32*4,A2	*DRAWTO 32				
	BSR	DRAW

	BSR	CENTER

	MOVE.L	A0,VG_PTR	

	RTS

	PAGE
* Draw the Helicopter Rotors
*HIND ROTORS
*PLOT 0, DRAWTO 1, 2, 3, 0, 4, 5		.B 0,1,2,3,0,4,5
*DRAWTO 6, 7, 4					.L 6,7,4
*PLOT 8, 9, 10, 8, 15, 16, 8			.B 8,9,A,8,F,10,8
*DRAWTO 13, 14, 8, 11, 12, 8			.L D,E,8,B,C,8
*PLOT 1, DRAWTO 5				.B 1,5
*PLOT 7, DRAWTO 3				.B 7,3
*PLOT 2, DRAWTO 6				.B 2,6
*PLOT 

*HIND ROTORS
D_HROT	MOVEA	VG_PTR,A0
	MOVEA	#PTBL,A1

	MOVE.W	#0*4,A2		*PLOT 0
	BSR	PLOT	

	MOVE.W 	#1*4,A2		*DRAWTO 1 
	BSR	DRAW	

	MOVE.W	#2*4,A2		*DRAWTO 2 
	BSR	DRAW	

	MOVE.W	#3*4,A2		*DRAWTO 3 
	BSR	DRAW	

	MOVE.W	#0*4,A2		*DRAWTO 0 
	BSR	DRAW	

	MOVE.W	#4*4,A2		*DRAWTO 4 
	BSR	DRAW	

	MOVE.W	#5*4,A2		*DRAWTO 5		
	BSR	DRAW	

	MOVE.W	#6*4,A2		*DRAWTO 6 
	BSR	DRAW	

	MOVE.W	#7*4,A2		*DRAWTO 7 
	BSR	DRAW	

	MOVE.W	#4*4,A2		*DRAWTO 4				
	BSR	DRAW	

	MOVE.W	#8*4,A2		*PLOT 8 
	BSR	PLOT	

	MOVE.W	#9*4,A2		*DRAWTO 9 
	BSR	DRAW	

	MOVE.W	#10*4,A2	*DRAWTO 10 
	BSR	DRAW	

	MOVE.W	#8*4,A2		*DRAWTO 8 
	BSR	DRAW	

	MOVE.W	#15*4,A2	*DRAWTO 15 
	BSR	DRAW	

	MOVE.W	#16*4,A2	*DRAWTO 16 
	BSR	DRAW	

	MOVE.W	#8*4,A2		*DRAWTO 8			
	BSR	DRAW	

	MOVE.W	#13*4,A2	*DRAWTO 13 
	BSR	DRAW	

	MOVE.W	#14*4,A2	*DRAWTO 14 
	BSR	DRAW	

	MOVE.W	#8*4,A2		*DRAWTO 8 
	BSR	DRAW	

	MOVE.W	#11*4,A2	*DRAWTO 11 
	BSR	DRAW	

	MOVE.W	#12*4,A2	*DRAWTO 12 
	BSR	DRAW	

	MOVE.W	#8*4,A2		*DRAWTO 8			
	BSR	DRAW	

	MOVE.W	#1*4,A2		*PLOT 1
	BSR	PLOT	

	MOVE.W	#5*4,A2		*DRAWTO 5				
	BSR	DRAW	

	MOVE.W	#7*4,A2		*PLOT 7 
	BSR	PLOT	

	MOVE.W	#3*4,A2		*DRAWTO 3				
	BSR	DRAW	

	MOVE.W	#2*4,A2		*PLOT 2 
	BSR	PLOT	

	MOVE.W	#6*4,A2		*DRAWTO 6				
	BSR	DRAW	


	BSR	CENTER

	MOVE.L	A0,VG_PTR

	RTS	

*				*ALTERNATE HIND ROTORS
*PLOT 0, DRAWTO 1				.B 0,1
*PLOT 2, DRAWTO 3				.B 2,3
*PLOT 4, DRAWTO 5				.B 4,5
*PLOT 6, DRAWTO 7				.B 6,7


*Old Way
*		      WORDS  CYCLES
*		      -----  ------
* MOVE.L  #PT*4,A2    	3      12
* ADD.L   A1,A2	      	1       8
* MOVE.W  Y(A2),D3    	2      12
* MOVE.W  X(A2),D3    	2      12
*                             ----
*			       44
*
*New Way
*
* MOVE.W  #PT*4,A2    	2       8
* MOVE.W  Y(A2,A1),D3 	2      14
* MOVE.W  X(A2,A1),D3 	2      14
* 			      ----
*			       36       
*New way saves 8 cycles and 1 word per point



* Draw the Cube
*CUBE
*PLOT 0, DRAWTO 1,2,3,0,4			.B 0,1,2,3,0,4
*DRAWTO  5,1,5,6,2,6				.L 5,1,5,6,2,6
*DRAWTO	 7,3,7,4				.L 7,3,7,4
*
* DRAW A CUBE 	A0 = VG ADDRESS POINTER

*Fastest Drawing Routine:
*First point after CENTER:
*   PLOTC n	
*	MOVE.W	PT{n}Y,D0		
*	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
*	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
*
*	MOVE.W	PT{n}X,D0
*	AND.W	#$1FFF,D0	* BRITE = OFF		[X]
*	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
*
*    DRAWTO m
*	MOVE.W	PT{m}Y,D0
*	SUB.W	PT{n}Y,D0
*	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
*	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
*		
*	MOVE.W	PT{m}X,D0
*	SUB.W	PT{n}X,D0
*	OR.W	#$E000,D3	* BRITE = ON		[X]
*	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
*    { let n = m }
*
*    PLOT m
*	MOVE.W	PT{m}Y,D0
*	SUB.W	PT{n}Y,D0
*	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
*	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
*		
*	MOVE.W	PT{m}X,D0
*	SUB.W	PT{n}X,D0
*	AND.W	#$1FFF,D0	* BRITE = OFF
*	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
*    { let n = m }
*
* Points will eventually be defined in EQUATES
PT0X	EQU	$0
PT0Y	EQU	$2
PT1X	EQU	$4
PT1Y	EQU	$6
PT2X	EQU	$8
PT2Y	EQU	$0A
PT3X	EQU	$0C
PT3Y	EQU	$0E
PT4X	EQU	$10
PT4Y	EQU	$12
PT5X	EQU	$14
PT5Y	EQU	$16
PT6X	EQU	$18
PT6Y	EQU	$1A
PT7X	EQU	$1C
PT7Y	EQU	$1E

FASTCUBE
	MOVEA	VG_PTR,A0
	MOVEA	#PTBL,A1

	MOVE.W 	#$7180,(A0)+	*SCALE BIN=1, LIN=80
	MOVE.W 	#$6780,(A0)+	*COLOR WHT, ZSTAT=80

*PLOT 0	
	MOVE.W	PT0Y(A1),D0		
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer

	MOVE.W	PT0X(A1),D0
	AND.W	#$1FFF,D0	* BRITE = OFF		[X]
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer


*DRAWTO 1
	MOVE.W	PT1Y(A1),D0
	SUB.W	PT0Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT1X(A1),D0
	SUB.W	PT0X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 2
	MOVE.W	PT2Y(A1),D0
	SUB.W	PT1Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT2X(A1),D0
	SUB.W	PT1X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
	
*DRAWTO 3
	MOVE.W	PT3Y(A1),D0
	SUB.W	PT2Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT3X(A1),D0
	SUB.W	PT2X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer


*DRAWTO 0
	MOVE.W	PT0Y(A1),D0
	SUB.W	PT3Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT0X(A1),D0
	SUB.W	PT3X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 4
	MOVE.W	PT4Y(A1),D0
	SUB.W	PT0Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT4X(A1),D0
	SUB.W	PT0X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 5
	MOVE.W	PT5Y(A1),D0
	SUB.W	PT4Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT5X(A1),D0
	SUB.W	PT4X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 1
	MOVE.W	PT1Y(A1),D0
	SUB.W	PT5Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT1X(A1),D0
	SUB.W	PT5X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 5
	MOVE.W	PT5Y(A1),D0
	SUB.W	PT1Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT5X(A1),D0
	SUB.W	PT1X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer


*DRAWTO 6
	MOVE.W	PT6Y(A1),D0
	SUB.W	PT5Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT6X(A1),D0
	SUB.W	PT5X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer


*DRAWTO 2
	MOVE.W	PT2Y(A1),D0
	SUB.W	PT6Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT2X(A1),D0
	SUB.W	PT6X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer


*DRAWTO 6
	MOVE.W	PT6Y(A1),D0
	SUB.W	PT2Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT6X(A1),D0
	SUB.W	PT2X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 7
	MOVE.W	PT7Y(A1),D0
	SUB.W	PT6Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT7X(A1),D0
	SUB.W	PT6X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 3
	MOVE.W	PT3Y(A1),D0
	SUB.W	PT7Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT3X(A1),D0
	SUB.W	PT7X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 7
	MOVE.W	PT7Y(A1),D0
	SUB.W	PT3Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT7X(A1),D0
	SUB.W	PT3X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer

*DRAWTO 4
	MOVE.W	PT4Y(A1),D0
	SUB.W	PT7Y(A1),D0
	AND.W	#$1FFF,D0	* VECTOR INSTRUCTION	[Y]	
	MOVE.W	D0,(A0)+	* WRITE TO VG BUFFER and increment pointer
		
	MOVE.W	PT4X(A1),D0
	SUB.W	PT7X(A1),D0
	OR.W	#$E000,D3	* BRITE = ON		[X]
	MOVE.W	D3,(A0)+	* WRITE TO VG BUFFER and increment pointer
	
	MOVE.W	#$8040,(A0)+	* CENTER COMMAND and increment pointer

	MOVE.L	A0,VG_PTR	

	RTS 	
FAST
DEND	END

